/*******************************************************************************
    Copyright (c) 2020, NVIDIA CORPORATION. All rights reserved.

    Permission is hereby granted, free of charge, to any person obtaining a
    copy of this software and associated documentation files (the "Software"),
    to deal in the Software without restriction, including without limitation
    the rights to use, copy, modify, merge, publish, distribute, sublicense,
    and/or sell copies of the Software, and to permit persons to whom the
    Software is furnished to do so, subject to the following conditions:

    The above copyright notice and this permission notice shall be included in
    all copies or substantial portions of the Software.

    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
    THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
    FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
    DEALINGS IN THE SOFTWARE.

*******************************************************************************/

/* AUTO GENERATED FILE -- DO NOT EDIT */

#ifndef __CLA097SPH_H__
#define __CLA097SPH_H__

/*
** Shader Program Header State, Version 3, Type 1
 */

#define NVA097_SPHV3T1_SPH_TYPE                                    MW(4:0)
#define NVA097_SPHV3T1_SPH_TYPE_TYPE_01_VTG                        0x00000001
#define NVA097_SPHV3T1_SPH_TYPE_TYPE_02_PS                         0x00000002
#define NVA097_SPHV3T1_VERSION                                     MW(9:5)
#define NVA097_SPHV3T1_SHADER_TYPE                                 MW(13:10)
#define NVA097_SPHV3T1_SHADER_TYPE_VERTEX                          0x00000001
#define NVA097_SPHV3T1_SHADER_TYPE_TESSELLATION_INIT               0x00000002
#define NVA097_SPHV3T1_SHADER_TYPE_TESSELLATION                    0x00000003
#define NVA097_SPHV3T1_SHADER_TYPE_GEOMETRY                        0x00000004
#define NVA097_SPHV3T1_SHADER_TYPE_PIXEL                           0x00000005
#define NVA097_SPHV3T1_MRT_ENABLE                                  MW(14:14)
#define NVA097_SPHV3T1_MRT_ENABLE_FALSE                            0x00000000
#define NVA097_SPHV3T1_MRT_ENABLE_TRUE                             0x00000001
#define NVA097_SPHV3T1_KILLS_PIXELS                                MW(15:15)
#define NVA097_SPHV3T1_KILLS_PIXELS_FALSE                          0x00000000
#define NVA097_SPHV3T1_KILLS_PIXELS_TRUE                           0x00000001
#define NVA097_SPHV3T1_DOES_GLOBAL_STORE                           MW(16:16)
#define NVA097_SPHV3T1_DOES_GLOBAL_STORE_FALSE                     0x00000000
#define NVA097_SPHV3T1_DOES_GLOBAL_STORE_TRUE                      0x00000001
#define NVA097_SPHV3T1_SASS_VERSION                                MW(20:17)
#define NVA097_SPHV3T1_RESERVED_COMMON_A(i)                        MW((21+(i)*1):(21+(i)*1))
#define NVA097_SPHV3T1_RESERVED_COMMON_A_FALSE                     0x00000000
#define NVA097_SPHV3T1_RESERVED_COMMON_A_TRUE                      0x00000001
#define NVA097_SPHV3T1_DOES_LOAD_OR_STORE                          MW(26:26)
#define NVA097_SPHV3T1_DOES_LOAD_OR_STORE_FALSE                    0x00000000
#define NVA097_SPHV3T1_DOES_LOAD_OR_STORE_TRUE                     0x00000001
#define NVA097_SPHV3T1_DOES_FP64                                   MW(27:27)
#define NVA097_SPHV3T1_DOES_FP64_FALSE                             0x00000000
#define NVA097_SPHV3T1_DOES_FP64_TRUE                              0x00000001
#define NVA097_SPHV3T1_STREAM_OUT_MASK                             MW(31:28)
#define NVA097_SPHV3T1_SHADER_LOCAL_MEMORY_LOW_SIZE                MW(55:32)
#define NVA097_SPHV3T1_PER_PATCH_ATTRIBUTE_COUNT                   MW(63:56)
#define NVA097_SPHV3T1_SHADER_LOCAL_MEMORY_HIGH_SIZE               MW(87:64)
#define NVA097_SPHV3T1_THREADS_PER_INPUT_PRIMITIVE                 MW(95:88)
#define NVA097_SPHV3T1_SHADER_LOCAL_MEMORY_CRS_SIZE                MW(119:96)
#define NVA097_SPHV3T1_OUTPUT_TOPOLOGY                             MW(123:120)
#define NVA097_SPHV3T1_OUTPUT_TOPOLOGY_POINTLIST                   0x00000001
#define NVA097_SPHV3T1_OUTPUT_TOPOLOGY_LINESTRIP                   0x00000006
#define NVA097_SPHV3T1_OUTPUT_TOPOLOGY_TRIANGLESTRIP               0x00000007
#define NVA097_SPHV3T1_RESERVED_COMMON_B                           MW(127:124)
#define NVA097_SPHV3T1_MAX_OUTPUT_VERTEX_COUNT                     MW(139:128)
#define NVA097_SPHV3T1_STORE_REQ_START                             MW(147:140)
#define NVA097_SPHV3T1_RESERVED_COMMON_C(i)                        MW((148+(i)*1):(148+(i)*1))
#define NVA097_SPHV3T1_RESERVED_COMMON_C_FALSE                     0x00000000
#define NVA097_SPHV3T1_RESERVED_COMMON_C_TRUE                      0x00000001
#define NVA097_SPHV3T1_STORE_REQ_END                               MW(159:152)
#define NVA097_SPHV3T1_IMAP_TESSELLATION_LOD_LEFT                  MW(164:164)
#define NVA097_SPHV3T1_IMAP_TESSELLATION_LOD_LEFT_FALSE            0x00000000
#define NVA097_SPHV3T1_IMAP_TESSELLATION_LOD_LEFT_TRUE             0x00000001
#define NVA097_SPHV3T1_IMAP_TESSELLATION_LOD_RIGHT                 MW(165:165)
#define NVA097_SPHV3T1_IMAP_TESSELLATION_LOD_RIGHT_FALSE           0x00000000
#define NVA097_SPHV3T1_IMAP_TESSELLATION_LOD_RIGHT_TRUE            0x00000001
#define NVA097_SPHV3T1_IMAP_TESSELLATION_LOD_BOTTOM                MW(166:166)
#define NVA097_SPHV3T1_IMAP_TESSELLATION_LOD_BOTTOM_FALSE          0x00000000
#define NVA097_SPHV3T1_IMAP_TESSELLATION_LOD_BOTTOM_TRUE           0x00000001
#define NVA097_SPHV3T1_IMAP_TESSELLATION_LOD_TOP                   MW(167:167)
#define NVA097_SPHV3T1_IMAP_TESSELLATION_LOD_TOP_FALSE             0x00000000
#define NVA097_SPHV3T1_IMAP_TESSELLATION_LOD_TOP_TRUE              0x00000001
#define NVA097_SPHV3T1_IMAP_TESSELLATION_INTERIOR_U                MW(168:168)
#define NVA097_SPHV3T1_IMAP_TESSELLATION_INTERIOR_U_FALSE          0x00000000
#define NVA097_SPHV3T1_IMAP_TESSELLATION_INTERIOR_U_TRUE           0x00000001
#define NVA097_SPHV3T1_IMAP_TESSELLATION_INTERIOR_V                MW(169:169)
#define NVA097_SPHV3T1_IMAP_TESSELLATION_INTERIOR_V_FALSE          0x00000000
#define NVA097_SPHV3T1_IMAP_TESSELLATION_INTERIOR_V_TRUE           0x00000001
#define NVA097_SPHV3T1_IMAP_PRIMITIVE_ID                           MW(184:184)
#define NVA097_SPHV3T1_IMAP_PRIMITIVE_ID_FALSE                     0x00000000
#define NVA097_SPHV3T1_IMAP_PRIMITIVE_ID_TRUE                      0x00000001
#define NVA097_SPHV3T1_IMAP_RT_ARRAY_INDEX                         MW(185:185)
#define NVA097_SPHV3T1_IMAP_RT_ARRAY_INDEX_FALSE                   0x00000000
#define NVA097_SPHV3T1_IMAP_RT_ARRAY_INDEX_TRUE                    0x00000001
#define NVA097_SPHV3T1_IMAP_VIEWPORT_INDEX                         MW(186:186)
#define NVA097_SPHV3T1_IMAP_VIEWPORT_INDEX_FALSE                   0x00000000
#define NVA097_SPHV3T1_IMAP_VIEWPORT_INDEX_TRUE                    0x00000001
#define NVA097_SPHV3T1_IMAP_POINT_SIZE                             MW(187:187)
#define NVA097_SPHV3T1_IMAP_POINT_SIZE_FALSE                       0x00000000
#define NVA097_SPHV3T1_IMAP_POINT_SIZE_TRUE                        0x00000001
#define NVA097_SPHV3T1_IMAP_POSITION_X                             MW(188:188)
#define NVA097_SPHV3T1_IMAP_POSITION_X_FALSE                       0x00000000
#define NVA097_SPHV3T1_IMAP_POSITION_X_TRUE                        0x00000001
#define NVA097_SPHV3T1_IMAP_POSITION_Y                             MW(189:189)
#define NVA097_SPHV3T1_IMAP_POSITION_Y_FALSE                       0x00000000
#define NVA097_SPHV3T1_IMAP_POSITION_Y_TRUE                        0x00000001
#define NVA097_SPHV3T1_IMAP_POSITION_Z                             MW(190:190)
#define NVA097_SPHV3T1_IMAP_POSITION_Z_FALSE                       0x00000000
#define NVA097_SPHV3T1_IMAP_POSITION_Z_TRUE                        0x00000001
#define NVA097_SPHV3T1_IMAP_POSITION_W                             MW(191:191)
#define NVA097_SPHV3T1_IMAP_POSITION_W_FALSE                       0x00000000
#define NVA097_SPHV3T1_IMAP_POSITION_W_TRUE                        0x00000001
#define NVA097_SPHV3T1_GENERIC_IMAP_X(i)                           MW((192+(i)*4):(192+(i)*4))
#define NVA097_SPHV3T1_GENERIC_IMAP_X_FALSE                        0x00000000
#define NVA097_SPHV3T1_GENERIC_IMAP_X_TRUE                         0x00000001
#define NVA097_SPHV3T1_GENERIC_IMAP_Y(i)                           MW((193+(i)*4):(193+(i)*4))
#define NVA097_SPHV3T1_GENERIC_IMAP_Y_FALSE                        0x00000000
#define NVA097_SPHV3T1_GENERIC_IMAP_Y_TRUE                         0x00000001
#define NVA097_SPHV3T1_GENERIC_IMAP_Z(i)                           MW((194+(i)*4):(194+(i)*4))
#define NVA097_SPHV3T1_GENERIC_IMAP_Z_FALSE                        0x00000000
#define NVA097_SPHV3T1_GENERIC_IMAP_Z_TRUE                         0x00000001
#define NVA097_SPHV3T1_GENERIC_IMAP_W(i)                           MW((195+(i)*4):(195+(i)*4))
#define NVA097_SPHV3T1_GENERIC_IMAP_W_FALSE                        0x00000000
#define NVA097_SPHV3T1_GENERIC_IMAP_W_TRUE                         0x00000001
#define NVA097_SPHV3T1_IMAP_COLOR_FRONT_DIFFUSE_RED                MW(320:320)
#define NVA097_SPHV3T1_IMAP_COLOR_FRONT_DIFFUSE_RED_FALSE          0x00000000
#define NVA097_SPHV3T1_IMAP_COLOR_FRONT_DIFFUSE_RED_TRUE           0x00000001
#define NVA097_SPHV3T1_IMAP_COLOR_FRONT_DIFFUSE_GREEN              MW(321:321)
#define NVA097_SPHV3T1_IMAP_COLOR_FRONT_DIFFUSE_GREEN_FALSE        0x00000000
#define NVA097_SPHV3T1_IMAP_COLOR_FRONT_DIFFUSE_GREEN_TRUE         0x00000001
#define NVA097_SPHV3T1_IMAP_COLOR_FRONT_DIFFUSE_BLUE               MW(322:322)
#define NVA097_SPHV3T1_IMAP_COLOR_FRONT_DIFFUSE_BLUE_FALSE         0x00000000
#define NVA097_SPHV3T1_IMAP_COLOR_FRONT_DIFFUSE_BLUE_TRUE          0x00000001
#define NVA097_SPHV3T1_IMAP_COLOR_FRONT_DIFFUSE_ALPHA              MW(323:323)
#define NVA097_SPHV3T1_IMAP_COLOR_FRONT_DIFFUSE_ALPHA_FALSE        0x00000000
#define NVA097_SPHV3T1_IMAP_COLOR_FRONT_DIFFUSE_ALPHA_TRUE         0x00000001
#define NVA097_SPHV3T1_IMAP_COLOR_FRONT_SPECULAR_RED               MW(324:324)
#define NVA097_SPHV3T1_IMAP_COLOR_FRONT_SPECULAR_RED_FALSE         0x00000000
#define NVA097_SPHV3T1_IMAP_COLOR_FRONT_SPECULAR_RED_TRUE          0x00000001
#define NVA097_SPHV3T1_IMAP_COLOR_FRONT_SPECULAR_GREEN             MW(325:325)
#define NVA097_SPHV3T1_IMAP_COLOR_FRONT_SPECULAR_GREEN_FALSE       0x00000000
#define NVA097_SPHV3T1_IMAP_COLOR_FRONT_SPECULAR_GREEN_TRUE        0x00000001
#define NVA097_SPHV3T1_IMAP_COLOR_FRONT_SPECULAR_BLUE              MW(326:326)
#define NVA097_SPHV3T1_IMAP_COLOR_FRONT_SPECULAR_BLUE_FALSE        0x00000000
#define NVA097_SPHV3T1_IMAP_COLOR_FRONT_SPECULAR_BLUE_TRUE         0x00000001
#define NVA097_SPHV3T1_IMAP_COLOR_FRONT_SPECULAR_ALPHA             MW(327:327)
#define NVA097_SPHV3T1_IMAP_COLOR_FRONT_SPECULAR_ALPHA_FALSE       0x00000000
#define NVA097_SPHV3T1_IMAP_COLOR_FRONT_SPECULAR_ALPHA_TRUE        0x00000001
#define NVA097_SPHV3T1_IMAP_COLOR_BACK_DIFFUSE_RED                 MW(328:328)
#define NVA097_SPHV3T1_IMAP_COLOR_BACK_DIFFUSE_RED_FALSE           0x00000000
#define NVA097_SPHV3T1_IMAP_COLOR_BACK_DIFFUSE_RED_TRUE            0x00000001
#define NVA097_SPHV3T1_IMAP_COLOR_BACK_DIFFUSE_GREEN               MW(329:329)
#define NVA097_SPHV3T1_IMAP_COLOR_BACK_DIFFUSE_GREEN_FALSE         0x00000000
#define NVA097_SPHV3T1_IMAP_COLOR_BACK_DIFFUSE_GREEN_TRUE          0x00000001
#define NVA097_SPHV3T1_IMAP_COLOR_BACK_DIFFUSE_BLUE                MW(330:330)
#define NVA097_SPHV3T1_IMAP_COLOR_BACK_DIFFUSE_BLUE_FALSE          0x00000000
#define NVA097_SPHV3T1_IMAP_COLOR_BACK_DIFFUSE_BLUE_TRUE           0x00000001
#define NVA097_SPHV3T1_IMAP_COLOR_BACK_DIFFUSE_ALPHA               MW(331:331)
#define NVA097_SPHV3T1_IMAP_COLOR_BACK_DIFFUSE_ALPHA_FALSE         0x00000000
#define NVA097_SPHV3T1_IMAP_COLOR_BACK_DIFFUSE_ALPHA_TRUE          0x00000001
#define NVA097_SPHV3T1_IMAP_COLOR_BACK_SPECULAR_RED                MW(332:332)
#define NVA097_SPHV3T1_IMAP_COLOR_BACK_SPECULAR_RED_FALSE          0x00000000
#define NVA097_SPHV3T1_IMAP_COLOR_BACK_SPECULAR_RED_TRUE           0x00000001
#define NVA097_SPHV3T1_IMAP_COLOR_BACK_SPECULAR_GREEN              MW(333:333)
#define NVA097_SPHV3T1_IMAP_COLOR_BACK_SPECULAR_GREEN_FALSE        0x00000000
#define NVA097_SPHV3T1_IMAP_COLOR_BACK_SPECULAR_GREEN_TRUE         0x00000001
#define NVA097_SPHV3T1_IMAP_COLOR_BACK_SPECULAR_BLUE               MW(334:334)
#define NVA097_SPHV3T1_IMAP_COLOR_BACK_SPECULAR_BLUE_FALSE         0x00000000
#define NVA097_SPHV3T1_IMAP_COLOR_BACK_SPECULAR_BLUE_TRUE          0x00000001
#define NVA097_SPHV3T1_IMAP_COLOR_BACK_SPECULAR_ALPHA              MW(335:335)
#define NVA097_SPHV3T1_IMAP_COLOR_BACK_SPECULAR_ALPHA_FALSE        0x00000000
#define NVA097_SPHV3T1_IMAP_COLOR_BACK_SPECULAR_ALPHA_TRUE         0x00000001
#define NVA097_SPHV3T1_IMAP_CLIP_DISTANCE0                         MW(336:336)
#define NVA097_SPHV3T1_IMAP_CLIP_DISTANCE0_FALSE                   0x00000000
#define NVA097_SPHV3T1_IMAP_CLIP_DISTANCE0_TRUE                    0x00000001
#define NVA097_SPHV3T1_IMAP_CLIP_DISTANCE1                         MW(337:337)
#define NVA097_SPHV3T1_IMAP_CLIP_DISTANCE1_FALSE                   0x00000000
#define NVA097_SPHV3T1_IMAP_CLIP_DISTANCE1_TRUE                    0x00000001
#define NVA097_SPHV3T1_IMAP_CLIP_DISTANCE2                         MW(338:338)
#define NVA097_SPHV3T1_IMAP_CLIP_DISTANCE2_FALSE                   0x00000000
#define NVA097_SPHV3T1_IMAP_CLIP_DISTANCE2_TRUE                    0x00000001
#define NVA097_SPHV3T1_IMAP_CLIP_DISTANCE3                         MW(339:339)
#define NVA097_SPHV3T1_IMAP_CLIP_DISTANCE3_FALSE                   0x00000000
#define NVA097_SPHV3T1_IMAP_CLIP_DISTANCE3_TRUE                    0x00000001
#define NVA097_SPHV3T1_IMAP_CLIP_DISTANCE4                         MW(340:340)
#define NVA097_SPHV3T1_IMAP_CLIP_DISTANCE4_FALSE                   0x00000000
#define NVA097_SPHV3T1_IMAP_CLIP_DISTANCE4_TRUE                    0x00000001
#define NVA097_SPHV3T1_IMAP_CLIP_DISTANCE5                         MW(341:341)
#define NVA097_SPHV3T1_IMAP_CLIP_DISTANCE5_FALSE                   0x00000000
#define NVA097_SPHV3T1_IMAP_CLIP_DISTANCE5_TRUE                    0x00000001
#define NVA097_SPHV3T1_IMAP_CLIP_DISTANCE6                         MW(342:342)
#define NVA097_SPHV3T1_IMAP_CLIP_DISTANCE6_FALSE                   0x00000000
#define NVA097_SPHV3T1_IMAP_CLIP_DISTANCE6_TRUE                    0x00000001
#define NVA097_SPHV3T1_IMAP_CLIP_DISTANCE7                         MW(343:343)
#define NVA097_SPHV3T1_IMAP_CLIP_DISTANCE7_FALSE                   0x00000000
#define NVA097_SPHV3T1_IMAP_CLIP_DISTANCE7_TRUE                    0x00000001
#define NVA097_SPHV3T1_IMAP_POINT_SPRITE_S                         MW(344:344)
#define NVA097_SPHV3T1_IMAP_POINT_SPRITE_S_FALSE                   0x00000000
#define NVA097_SPHV3T1_IMAP_POINT_SPRITE_S_TRUE                    0x00000001
#define NVA097_SPHV3T1_IMAP_POINT_SPRITE_T                         MW(345:345)
#define NVA097_SPHV3T1_IMAP_POINT_SPRITE_T_FALSE                   0x00000000
#define NVA097_SPHV3T1_IMAP_POINT_SPRITE_T_TRUE                    0x00000001
#define NVA097_SPHV3T1_IMAP_FOG_COORDINATE                         MW(346:346)
#define NVA097_SPHV3T1_IMAP_FOG_COORDINATE_FALSE                   0x00000000
#define NVA097_SPHV3T1_IMAP_FOG_COORDINATE_TRUE                    0x00000001
#define NVA097_SPHV3T1_IMAP_TESSELLATION_EVALUATION_POINT_U        MW(348:348)
#define NVA097_SPHV3T1_IMAP_TESSELLATION_EVALUATION_POINT_U_FALSE  0x00000000
#define NVA097_SPHV3T1_IMAP_TESSELLATION_EVALUATION_POINT_U_TRUE   0x00000001
#define NVA097_SPHV3T1_IMAP_TESSELLATION_EVALUATION_POINT_V        MW(349:349)
#define NVA097_SPHV3T1_IMAP_TESSELLATION_EVALUATION_POINT_V_FALSE  0x00000000
#define NVA097_SPHV3T1_IMAP_TESSELLATION_EVALUATION_POINT_V_TRUE   0x00000001
#define NVA097_SPHV3T1_IMAP_INSTANCE_ID                            MW(350:350)
#define NVA097_SPHV3T1_IMAP_INSTANCE_ID_FALSE                      0x00000000
#define NVA097_SPHV3T1_IMAP_INSTANCE_ID_TRUE                       0x00000001
#define NVA097_SPHV3T1_IMAP_VERTEX_ID                              MW(351:351)
#define NVA097_SPHV3T1_IMAP_VERTEX_ID_FALSE                        0x00000000
#define NVA097_SPHV3T1_IMAP_VERTEX_ID_TRUE                         0x00000001
#define NVA097_SPHV3T1_TEX_IMAP_S(i)                               MW((352+(i)*4):(352+(i)*4))
#define NVA097_SPHV3T1_TEX_IMAP_S_FALSE                            0x00000000
#define NVA097_SPHV3T1_TEX_IMAP_S_TRUE                             0x00000001
#define NVA097_SPHV3T1_TEX_IMAP_T(i)                               MW((353+(i)*4):(353+(i)*4))
#define NVA097_SPHV3T1_TEX_IMAP_T_FALSE                            0x00000000
#define NVA097_SPHV3T1_TEX_IMAP_T_TRUE                             0x00000001
#define NVA097_SPHV3T1_TEX_IMAP_R(i)                               MW((354+(i)*4):(354+(i)*4))
#define NVA097_SPHV3T1_TEX_IMAP_R_FALSE                            0x00000000
#define NVA097_SPHV3T1_TEX_IMAP_R_TRUE                             0x00000001
#define NVA097_SPHV3T1_TEX_IMAP_Q(i)                               MW((355+(i)*4):(355+(i)*4))
#define NVA097_SPHV3T1_TEX_IMAP_Q_FALSE                            0x00000000
#define NVA097_SPHV3T1_TEX_IMAP_Q_TRUE                             0x00000001
#define NVA097_SPHV3T1_OMAP_TESSELLATION_LOD_LEFT                  MW(404:404)
#define NVA097_SPHV3T1_OMAP_TESSELLATION_LOD_LEFT_FALSE            0x00000000
#define NVA097_SPHV3T1_OMAP_TESSELLATION_LOD_LEFT_TRUE             0x00000001
#define NVA097_SPHV3T1_OMAP_TESSELLATION_LOD_RIGHT                 MW(405:405)
#define NVA097_SPHV3T1_OMAP_TESSELLATION_LOD_RIGHT_FALSE           0x00000000
#define NVA097_SPHV3T1_OMAP_TESSELLATION_LOD_RIGHT_TRUE            0x00000001
#define NVA097_SPHV3T1_OMAP_TESSELLATION_LOD_BOTTOM                MW(406:406)
#define NVA097_SPHV3T1_OMAP_TESSELLATION_LOD_BOTTOM_FALSE          0x00000000
#define NVA097_SPHV3T1_OMAP_TESSELLATION_LOD_BOTTOM_TRUE           0x00000001
#define NVA097_SPHV3T1_OMAP_TESSELLATION_LOD_TOP                   MW(407:407)
#define NVA097_SPHV3T1_OMAP_TESSELLATION_LOD_TOP_FALSE             0x00000000
#define NVA097_SPHV3T1_OMAP_TESSELLATION_LOD_TOP_TRUE              0x00000001
#define NVA097_SPHV3T1_OMAP_TESSELLATION_INTERIOR_U                MW(408:408)
#define NVA097_SPHV3T1_OMAP_TESSELLATION_INTERIOR_U_FALSE          0x00000000
#define NVA097_SPHV3T1_OMAP_TESSELLATION_INTERIOR_U_TRUE           0x00000001
#define NVA097_SPHV3T1_OMAP_TESSELLATION_INTERIOR_V                MW(409:409)
#define NVA097_SPHV3T1_OMAP_TESSELLATION_INTERIOR_V_FALSE          0x00000000
#define NVA097_SPHV3T1_OMAP_TESSELLATION_INTERIOR_V_TRUE           0x00000001
#define NVA097_SPHV3T1_OMAP_PRIMITIVE_ID                           MW(424:424)
#define NVA097_SPHV3T1_OMAP_PRIMITIVE_ID_FALSE                     0x00000000
#define NVA097_SPHV3T1_OMAP_PRIMITIVE_ID_TRUE                      0x00000001
#define NVA097_SPHV3T1_OMAP_RT_ARRAY_INDEX                         MW(425:425)
#define NVA097_SPHV3T1_OMAP_RT_ARRAY_INDEX_FALSE                   0x00000000
#define NVA097_SPHV3T1_OMAP_RT_ARRAY_INDEX_TRUE                    0x00000001
#define NVA097_SPHV3T1_OMAP_VIEWPORT_INDEX                         MW(426:426)
#define NVA097_SPHV3T1_OMAP_VIEWPORT_INDEX_FALSE                   0x00000000
#define NVA097_SPHV3T1_OMAP_VIEWPORT_INDEX_TRUE                    0x00000001
#define NVA097_SPHV3T1_OMAP_POINT_SIZE                             MW(427:427)
#define NVA097_SPHV3T1_OMAP_POINT_SIZE_FALSE                       0x00000000
#define NVA097_SPHV3T1_OMAP_POINT_SIZE_TRUE                        0x00000001
#define NVA097_SPHV3T1_OMAP_POSITION_X                             MW(428:428)
#define NVA097_SPHV3T1_OMAP_POSITION_X_FALSE                       0x00000000
#define NVA097_SPHV3T1_OMAP_POSITION_X_TRUE                        0x00000001
#define NVA097_SPHV3T1_OMAP_POSITION_Y                             MW(429:429)
#define NVA097_SPHV3T1_OMAP_POSITION_Y_FALSE                       0x00000000
#define NVA097_SPHV3T1_OMAP_POSITION_Y_TRUE                        0x00000001
#define NVA097_SPHV3T1_OMAP_POSITION_Z                             MW(430:430)
#define NVA097_SPHV3T1_OMAP_POSITION_Z_FALSE                       0x00000000
#define NVA097_SPHV3T1_OMAP_POSITION_Z_TRUE                        0x00000001
#define NVA097_SPHV3T1_OMAP_POSITION_W                             MW(431:431)
#define NVA097_SPHV3T1_OMAP_POSITION_W_FALSE                       0x00000000
#define NVA097_SPHV3T1_OMAP_POSITION_W_TRUE                        0x00000001
#define NVA097_SPHV3T1_GENERIC_OMAP_X(i)                           MW((432+(i)*4):(432+(i)*4))
#define NVA097_SPHV3T1_GENERIC_OMAP_X_FALSE                        0x00000000
#define NVA097_SPHV3T1_GENERIC_OMAP_X_TRUE                         0x00000001
#define NVA097_SPHV3T1_GENERIC_OMAP_Y(i)                           MW((433+(i)*4):(433+(i)*4))
#define NVA097_SPHV3T1_GENERIC_OMAP_Y_FALSE                        0x00000000
#define NVA097_SPHV3T1_GENERIC_OMAP_Y_TRUE                         0x00000001
#define NVA097_SPHV3T1_GENERIC_OMAP_Z(i)                           MW((434+(i)*4):(434+(i)*4))
#define NVA097_SPHV3T1_GENERIC_OMAP_Z_FALSE                        0x00000000
#define NVA097_SPHV3T1_GENERIC_OMAP_Z_TRUE                         0x00000001
#define NVA097_SPHV3T1_GENERIC_OMAP_W(i)                           MW((435+(i)*4):(435+(i)*4))
#define NVA097_SPHV3T1_GENERIC_OMAP_W_FALSE                        0x00000000
#define NVA097_SPHV3T1_GENERIC_OMAP_W_TRUE                         0x00000001
#define NVA097_SPHV3T1_OMAP_COLOR_FRONT_DIFFUSE_RED                MW(560:560)
#define NVA097_SPHV3T1_OMAP_COLOR_FRONT_DIFFUSE_RED_FALSE          0x00000000
#define NVA097_SPHV3T1_OMAP_COLOR_FRONT_DIFFUSE_RED_TRUE           0x00000001
#define NVA097_SPHV3T1_OMAP_COLOR_FRONT_DIFFUSE_GREEN              MW(561:561)
#define NVA097_SPHV3T1_OMAP_COLOR_FRONT_DIFFUSE_GREEN_FALSE        0x00000000
#define NVA097_SPHV3T1_OMAP_COLOR_FRONT_DIFFUSE_GREEN_TRUE         0x00000001
#define NVA097_SPHV3T1_OMAP_COLOR_FRONT_DIFFUSE_BLUE               MW(562:562)
#define NVA097_SPHV3T1_OMAP_COLOR_FRONT_DIFFUSE_BLUE_FALSE         0x00000000
#define NVA097_SPHV3T1_OMAP_COLOR_FRONT_DIFFUSE_BLUE_TRUE          0x00000001
#define NVA097_SPHV3T1_OMAP_COLOR_FRONT_DIFFUSE_ALPHA              MW(563:563)
#define NVA097_SPHV3T1_OMAP_COLOR_FRONT_DIFFUSE_ALPHA_FALSE        0x00000000
#define NVA097_SPHV3T1_OMAP_COLOR_FRONT_DIFFUSE_ALPHA_TRUE         0x00000001
#define NVA097_SPHV3T1_OMAP_COLOR_FRONT_SPECULAR_RED               MW(564:564)
#define NVA097_SPHV3T1_OMAP_COLOR_FRONT_SPECULAR_RED_FALSE         0x00000000
#define NVA097_SPHV3T1_OMAP_COLOR_FRONT_SPECULAR_RED_TRUE          0x00000001
#define NVA097_SPHV3T1_OMAP_COLOR_FRONT_SPECULAR_GREEN             MW(565:565)
#define NVA097_SPHV3T1_OMAP_COLOR_FRONT_SPECULAR_GREEN_FALSE       0x00000000
#define NVA097_SPHV3T1_OMAP_COLOR_FRONT_SPECULAR_GREEN_TRUE        0x00000001
#define NVA097_SPHV3T1_OMAP_COLOR_FRONT_SPECULAR_BLUE              MW(566:566)
#define NVA097_SPHV3T1_OMAP_COLOR_FRONT_SPECULAR_BLUE_FALSE        0x00000000
#define NVA097_SPHV3T1_OMAP_COLOR_FRONT_SPECULAR_BLUE_TRUE         0x00000001
#define NVA097_SPHV3T1_OMAP_COLOR_FRONT_SPECULAR_ALPHA             MW(567:567)
#define NVA097_SPHV3T1_OMAP_COLOR_FRONT_SPECULAR_ALPHA_FALSE       0x00000000
#define NVA097_SPHV3T1_OMAP_COLOR_FRONT_SPECULAR_ALPHA_TRUE        0x00000001
#define NVA097_SPHV3T1_OMAP_COLOR_BACK_DIFFUSE_RED                 MW(568:568)
#define NVA097_SPHV3T1_OMAP_COLOR_BACK_DIFFUSE_RED_FALSE           0x00000000
#define NVA097_SPHV3T1_OMAP_COLOR_BACK_DIFFUSE_RED_TRUE            0x00000001
#define NVA097_SPHV3T1_OMAP_COLOR_BACK_DIFFUSE_GREEN               MW(569:569)
#define NVA097_SPHV3T1_OMAP_COLOR_BACK_DIFFUSE_GREEN_FALSE         0x00000000
#define NVA097_SPHV3T1_OMAP_COLOR_BACK_DIFFUSE_GREEN_TRUE          0x00000001
#define NVA097_SPHV3T1_OMAP_COLOR_BACK_DIFFUSE_BLUE                MW(570:570)
#define NVA097_SPHV3T1_OMAP_COLOR_BACK_DIFFUSE_BLUE_FALSE          0x00000000
#define NVA097_SPHV3T1_OMAP_COLOR_BACK_DIFFUSE_BLUE_TRUE           0x00000001
#define NVA097_SPHV3T1_OMAP_COLOR_BACK_DIFFUSE_ALPHA               MW(571:571)
#define NVA097_SPHV3T1_OMAP_COLOR_BACK_DIFFUSE_ALPHA_FALSE         0x00000000
#define NVA097_SPHV3T1_OMAP_COLOR_BACK_DIFFUSE_ALPHA_TRUE          0x00000001
#define NVA097_SPHV3T1_OMAP_COLOR_BACK_SPECULAR_RED                MW(572:572)
#define NVA097_SPHV3T1_OMAP_COLOR_BACK_SPECULAR_RED_FALSE          0x00000000
#define NVA097_SPHV3T1_OMAP_COLOR_BACK_SPECULAR_RED_TRUE           0x00000001
#define NVA097_SPHV3T1_OMAP_COLOR_BACK_SPECULAR_GREEN              MW(573:573)
#define NVA097_SPHV3T1_OMAP_COLOR_BACK_SPECULAR_GREEN_FALSE        0x00000000
#define NVA097_SPHV3T1_OMAP_COLOR_BACK_SPECULAR_GREEN_TRUE         0x00000001
#define NVA097_SPHV3T1_OMAP_COLOR_BACK_SPECULAR_BLUE               MW(574:574)
#define NVA097_SPHV3T1_OMAP_COLOR_BACK_SPECULAR_BLUE_FALSE         0x00000000
#define NVA097_SPHV3T1_OMAP_COLOR_BACK_SPECULAR_BLUE_TRUE          0x00000001
#define NVA097_SPHV3T1_OMAP_COLOR_BACK_SPECULAR_ALPHA              MW(575:575)
#define NVA097_SPHV3T1_OMAP_COLOR_BACK_SPECULAR_ALPHA_FALSE        0x00000000
#define NVA097_SPHV3T1_OMAP_COLOR_BACK_SPECULAR_ALPHA_TRUE         0x00000001
#define NVA097_SPHV3T1_OMAP_CLIP_DISTANCE0                         MW(576:576)
#define NVA097_SPHV3T1_OMAP_CLIP_DISTANCE0_FALSE                   0x00000000
#define NVA097_SPHV3T1_OMAP_CLIP_DISTANCE0_TRUE                    0x00000001
#define NVA097_SPHV3T1_OMAP_CLIP_DISTANCE1                         MW(577:577)
#define NVA097_SPHV3T1_OMAP_CLIP_DISTANCE1_FALSE                   0x00000000
#define NVA097_SPHV3T1_OMAP_CLIP_DISTANCE1_TRUE                    0x00000001
#define NVA097_SPHV3T1_OMAP_CLIP_DISTANCE2                         MW(578:578)
#define NVA097_SPHV3T1_OMAP_CLIP_DISTANCE2_FALSE                   0x00000000
#define NVA097_SPHV3T1_OMAP_CLIP_DISTANCE2_TRUE                    0x00000001
#define NVA097_SPHV3T1_OMAP_CLIP_DISTANCE3                         MW(579:579)
#define NVA097_SPHV3T1_OMAP_CLIP_DISTANCE3_FALSE                   0x00000000
#define NVA097_SPHV3T1_OMAP_CLIP_DISTANCE3_TRUE                    0x00000001
#define NVA097_SPHV3T1_OMAP_CLIP_DISTANCE4                         MW(580:580)
#define NVA097_SPHV3T1_OMAP_CLIP_DISTANCE4_FALSE                   0x00000000
#define NVA097_SPHV3T1_OMAP_CLIP_DISTANCE4_TRUE                    0x00000001
#define NVA097_SPHV3T1_OMAP_CLIP_DISTANCE5                         MW(581:581)
#define NVA097_SPHV3T1_OMAP_CLIP_DISTANCE5_FALSE                   0x00000000
#define NVA097_SPHV3T1_OMAP_CLIP_DISTANCE5_TRUE                    0x00000001
#define NVA097_SPHV3T1_OMAP_CLIP_DISTANCE6                         MW(582:582)
#define NVA097_SPHV3T1_OMAP_CLIP_DISTANCE6_FALSE                   0x00000000
#define NVA097_SPHV3T1_OMAP_CLIP_DISTANCE6_TRUE                    0x00000001
#define NVA097_SPHV3T1_OMAP_CLIP_DISTANCE7                         MW(583:583)
#define NVA097_SPHV3T1_OMAP_CLIP_DISTANCE7_FALSE                   0x00000000
#define NVA097_SPHV3T1_OMAP_CLIP_DISTANCE7_TRUE                    0x00000001
#define NVA097_SPHV3T1_OMAP_POINT_SPRITE_S                         MW(584:584)
#define NVA097_SPHV3T1_OMAP_POINT_SPRITE_S_FALSE                   0x00000000
#define NVA097_SPHV3T1_OMAP_POINT_SPRITE_S_TRUE                    0x00000001
#define NVA097_SPHV3T1_OMAP_POINT_SPRITE_T                         MW(585:585)
#define NVA097_SPHV3T1_OMAP_POINT_SPRITE_T_FALSE                   0x00000000
#define NVA097_SPHV3T1_OMAP_POINT_SPRITE_T_TRUE                    0x00000001
#define NVA097_SPHV3T1_OMAP_FOG_COORDINATE                         MW(586:586)
#define NVA097_SPHV3T1_OMAP_FOG_COORDINATE_FALSE                   0x00000000
#define NVA097_SPHV3T1_OMAP_FOG_COORDINATE_TRUE                    0x00000001
#define NVA097_SPHV3T1_OMAP_TESSELLATION_EVALUATION_POINT_U        MW(588:588)
#define NVA097_SPHV3T1_OMAP_TESSELLATION_EVALUATION_POINT_U_FALSE  0x00000000
#define NVA097_SPHV3T1_OMAP_TESSELLATION_EVALUATION_POINT_U_TRUE   0x00000001
#define NVA097_SPHV3T1_OMAP_TESSELLATION_EVALUATION_POINT_V        MW(589:589)
#define NVA097_SPHV3T1_OMAP_TESSELLATION_EVALUATION_POINT_V_FALSE  0x00000000
#define NVA097_SPHV3T1_OMAP_TESSELLATION_EVALUATION_POINT_V_TRUE   0x00000001
#define NVA097_SPHV3T1_OMAP_INSTANCE_ID                            MW(590:590)
#define NVA097_SPHV3T1_OMAP_INSTANCE_ID_FALSE                      0x00000000
#define NVA097_SPHV3T1_OMAP_INSTANCE_ID_TRUE                       0x00000001
#define NVA097_SPHV3T1_OMAP_VERTEX_ID                              MW(591:591)
#define NVA097_SPHV3T1_OMAP_VERTEX_ID_FALSE                        0x00000000
#define NVA097_SPHV3T1_OMAP_VERTEX_ID_TRUE                         0x00000001
#define NVA097_SPHV3T1_TEX_OMAP_S(i)                               MW((592+(i)*4):(592+(i)*4))
#define NVA097_SPHV3T1_TEX_OMAP_S_FALSE                            0x00000000
#define NVA097_SPHV3T1_TEX_OMAP_S_TRUE                             0x00000001
#define NVA097_SPHV3T1_TEX_OMAP_T(i)                               MW((593+(i)*4):(593+(i)*4))
#define NVA097_SPHV3T1_TEX_OMAP_T_FALSE                            0x00000000
#define NVA097_SPHV3T1_TEX_OMAP_T_TRUE                             0x00000001
#define NVA097_SPHV3T1_TEX_OMAP_R(i)                               MW((594+(i)*4):(594+(i)*4))
#define NVA097_SPHV3T1_TEX_OMAP_R_FALSE                            0x00000000
#define NVA097_SPHV3T1_TEX_OMAP_R_TRUE                             0x00000001
#define NVA097_SPHV3T1_TEX_OMAP_Q(i)                               MW((595+(i)*4):(595+(i)*4))
#define NVA097_SPHV3T1_TEX_OMAP_Q_FALSE                            0x00000000
#define NVA097_SPHV3T1_TEX_OMAP_Q_TRUE                             0x00000001


/*
** Shader Program Header State, Version 3, Type 2
 */

#define NVA097_SPHV3T2_SPH_TYPE                                    MW(4:0)
#define NVA097_SPHV3T2_SPH_TYPE_TYPE_01_VTG                        0x00000001
#define NVA097_SPHV3T2_SPH_TYPE_TYPE_02_PS                         0x00000002
#define NVA097_SPHV3T2_VERSION                                     MW(9:5)
#define NVA097_SPHV3T2_SHADER_TYPE                                 MW(13:10)
#define NVA097_SPHV3T2_SHADER_TYPE_VERTEX                          0x00000001
#define NVA097_SPHV3T2_SHADER_TYPE_TESSELLATION_INIT               0x00000002
#define NVA097_SPHV3T2_SHADER_TYPE_TESSELLATION                    0x00000003
#define NVA097_SPHV3T2_SHADER_TYPE_GEOMETRY                        0x00000004
#define NVA097_SPHV3T2_SHADER_TYPE_PIXEL                           0x00000005
#define NVA097_SPHV3T2_MRT_ENABLE                                  MW(14:14)
#define NVA097_SPHV3T2_MRT_ENABLE_FALSE                            0x00000000
#define NVA097_SPHV3T2_MRT_ENABLE_TRUE                             0x00000001
#define NVA097_SPHV3T2_KILLS_PIXELS                                MW(15:15)
#define NVA097_SPHV3T2_KILLS_PIXELS_FALSE                          0x00000000
#define NVA097_SPHV3T2_KILLS_PIXELS_TRUE                           0x00000001
#define NVA097_SPHV3T2_DOES_GLOBAL_STORE                           MW(16:16)
#define NVA097_SPHV3T2_DOES_GLOBAL_STORE_FALSE                     0x00000000
#define NVA097_SPHV3T2_DOES_GLOBAL_STORE_TRUE                      0x00000001
#define NVA097_SPHV3T2_SASS_VERSION                                MW(20:17)
#define NVA097_SPHV3T2_RESERVED_COMMON_A(i)                        MW((21+(i)*1):(21+(i)*1))
#define NVA097_SPHV3T2_RESERVED_COMMON_A_FALSE                     0x00000000
#define NVA097_SPHV3T2_RESERVED_COMMON_A_TRUE                      0x00000001
#define NVA097_SPHV3T2_DOES_LOAD_OR_STORE                          MW(26:26)
#define NVA097_SPHV3T2_DOES_LOAD_OR_STORE_FALSE                    0x00000000
#define NVA097_SPHV3T2_DOES_LOAD_OR_STORE_TRUE                     0x00000001
#define NVA097_SPHV3T2_DOES_FP64                                   MW(27:27)
#define NVA097_SPHV3T2_DOES_FP64_FALSE                             0x00000000
#define NVA097_SPHV3T2_DOES_FP64_TRUE                              0x00000001
#define NVA097_SPHV3T2_STREAM_OUT_MASK                             MW(31:28)
#define NVA097_SPHV3T2_SHADER_LOCAL_MEMORY_LOW_SIZE                MW(55:32)
#define NVA097_SPHV3T2_PER_PATCH_ATTRIBUTE_COUNT                   MW(63:56)
#define NVA097_SPHV3T2_SHADER_LOCAL_MEMORY_HIGH_SIZE               MW(87:64)
#define NVA097_SPHV3T2_THREADS_PER_INPUT_PRIMITIVE                 MW(95:88)
#define NVA097_SPHV3T2_SHADER_LOCAL_MEMORY_CRS_SIZE                MW(119:96)
#define NVA097_SPHV3T2_OUTPUT_TOPOLOGY                             MW(123:120)
#define NVA097_SPHV3T2_OUTPUT_TOPOLOGY_POINTLIST                   0x00000001
#define NVA097_SPHV3T2_OUTPUT_TOPOLOGY_LINESTRIP                   0x00000006
#define NVA097_SPHV3T2_OUTPUT_TOPOLOGY_TRIANGLESTRIP               0x00000007
#define NVA097_SPHV3T2_RESERVED_COMMON_B                           MW(127:124)
#define NVA097_SPHV3T2_MAX_OUTPUT_VERTEX_COUNT                     MW(139:128)
#define NVA097_SPHV3T2_STORE_REQ_START                             MW(147:140)
#define NVA097_SPHV3T2_RESERVED_COMMON_C(i)                        MW((148+(i)*1):(148+(i)*1))
#define NVA097_SPHV3T2_RESERVED_COMMON_C_FALSE                     0x00000000
#define NVA097_SPHV3T2_RESERVED_COMMON_C_TRUE                      0x00000001
#define NVA097_SPHV3T2_STORE_REQ_END                               MW(159:152)
#define NVA097_SPHV3T2_IMAP_TESSELLATION_LOD_LEFT                  MW(164:164)
#define NVA097_SPHV3T2_IMAP_TESSELLATION_LOD_LEFT_FALSE            0x00000000
#define NVA097_SPHV3T2_IMAP_TESSELLATION_LOD_LEFT_TRUE             0x00000001
#define NVA097_SPHV3T2_IMAP_TESSELLATION_LOD_RIGHT                 MW(165:165)
#define NVA097_SPHV3T2_IMAP_TESSELLATION_LOD_RIGHT_FALSE           0x00000000
#define NVA097_SPHV3T2_IMAP_TESSELLATION_LOD_RIGHT_TRUE            0x00000001
#define NVA097_SPHV3T2_IMAP_TESSELLATION_LOD_BOTTOM                MW(166:166)
#define NVA097_SPHV3T2_IMAP_TESSELLATION_LOD_BOTTOM_FALSE          0x00000000
#define NVA097_SPHV3T2_IMAP_TESSELLATION_LOD_BOTTOM_TRUE           0x00000001
#define NVA097_SPHV3T2_IMAP_TESSELLATION_LOD_TOP                   MW(167:167)
#define NVA097_SPHV3T2_IMAP_TESSELLATION_LOD_TOP_FALSE             0x00000000
#define NVA097_SPHV3T2_IMAP_TESSELLATION_LOD_TOP_TRUE              0x00000001
#define NVA097_SPHV3T2_IMAP_TESSELLATION_INTERIOR_U                MW(168:168)
#define NVA097_SPHV3T2_IMAP_TESSELLATION_INTERIOR_U_FALSE          0x00000000
#define NVA097_SPHV3T2_IMAP_TESSELLATION_INTERIOR_U_TRUE           0x00000001
#define NVA097_SPHV3T2_IMAP_TESSELLATION_INTERIOR_V                MW(169:169)
#define NVA097_SPHV3T2_IMAP_TESSELLATION_INTERIOR_V_FALSE          0x00000000
#define NVA097_SPHV3T2_IMAP_TESSELLATION_INTERIOR_V_TRUE           0x00000001
#define NVA097_SPHV3T2_IMAP_PRIMITIVE_ID                           MW(184:184)
#define NVA097_SPHV3T2_IMAP_PRIMITIVE_ID_FALSE                     0x00000000
#define NVA097_SPHV3T2_IMAP_PRIMITIVE_ID_TRUE                      0x00000001
#define NVA097_SPHV3T2_IMAP_RT_ARRAY_INDEX                         MW(185:185)
#define NVA097_SPHV3T2_IMAP_RT_ARRAY_INDEX_FALSE                   0x00000000
#define NVA097_SPHV3T2_IMAP_RT_ARRAY_INDEX_TRUE                    0x00000001
#define NVA097_SPHV3T2_IMAP_VIEWPORT_INDEX                         MW(186:186)
#define NVA097_SPHV3T2_IMAP_VIEWPORT_INDEX_FALSE                   0x00000000
#define NVA097_SPHV3T2_IMAP_VIEWPORT_INDEX_TRUE                    0x00000001
#define NVA097_SPHV3T2_IMAP_POINT_SIZE                             MW(187:187)
#define NVA097_SPHV3T2_IMAP_POINT_SIZE_FALSE                       0x00000000
#define NVA097_SPHV3T2_IMAP_POINT_SIZE_TRUE                        0x00000001
#define NVA097_SPHV3T2_IMAP_POSITION_X                             MW(188:188)
#define NVA097_SPHV3T2_IMAP_POSITION_X_FALSE                       0x00000000
#define NVA097_SPHV3T2_IMAP_POSITION_X_TRUE                        0x00000001
#define NVA097_SPHV3T2_IMAP_POSITION_Y                             MW(189:189)
#define NVA097_SPHV3T2_IMAP_POSITION_Y_FALSE                       0x00000000
#define NVA097_SPHV3T2_IMAP_POSITION_Y_TRUE                        0x00000001
#define NVA097_SPHV3T2_IMAP_POSITION_Z                             MW(190:190)
#define NVA097_SPHV3T2_IMAP_POSITION_Z_FALSE                       0x00000000
#define NVA097_SPHV3T2_IMAP_POSITION_Z_TRUE                        0x00000001
#define NVA097_SPHV3T2_IMAP_POSITION_W                             MW(191:191)
#define NVA097_SPHV3T2_IMAP_POSITION_W_FALSE                       0x00000000
#define NVA097_SPHV3T2_IMAP_POSITION_W_TRUE                        0x00000001
#define NVA097_SPHV3T2_GENERIC_IMAP_X(i)                           MW((193+(i)*8):(192+(i)*8))
#define NVA097_SPHV3T2_GENERIC_IMAP_X_UNUSED                       0x00000000
#define NVA097_SPHV3T2_GENERIC_IMAP_X_CONSTANT                     0x00000001
#define NVA097_SPHV3T2_GENERIC_IMAP_X_PERSPECTIVE                  0x00000002
#define NVA097_SPHV3T2_GENERIC_IMAP_X_SCREEN_LINEAR                0x00000003
#define NVA097_SPHV3T2_GENERIC_IMAP_Y(i)                           MW((195+(i)*8):(194+(i)*8))
#define NVA097_SPHV3T2_GENERIC_IMAP_Y_UNUSED                       0x00000000
#define NVA097_SPHV3T2_GENERIC_IMAP_Y_CONSTANT                     0x00000001
#define NVA097_SPHV3T2_GENERIC_IMAP_Y_PERSPECTIVE                  0x00000002
#define NVA097_SPHV3T2_GENERIC_IMAP_Y_SCREEN_LINEAR                0x00000003
#define NVA097_SPHV3T2_GENERIC_IMAP_Z(i)                           MW((197+(i)*8):(196+(i)*8))
#define NVA097_SPHV3T2_GENERIC_IMAP_Z_UNUSED                       0x00000000
#define NVA097_SPHV3T2_GENERIC_IMAP_Z_CONSTANT                     0x00000001
#define NVA097_SPHV3T2_GENERIC_IMAP_Z_PERSPECTIVE                  0x00000002
#define NVA097_SPHV3T2_GENERIC_IMAP_Z_SCREEN_LINEAR                0x00000003
#define NVA097_SPHV3T2_GENERIC_IMAP_W(i)                           MW((199+(i)*8):(198+(i)*8))
#define NVA097_SPHV3T2_GENERIC_IMAP_W_UNUSED                       0x00000000
#define NVA097_SPHV3T2_GENERIC_IMAP_W_CONSTANT                     0x00000001
#define NVA097_SPHV3T2_GENERIC_IMAP_W_PERSPECTIVE                  0x00000002
#define NVA097_SPHV3T2_GENERIC_IMAP_W_SCREEN_LINEAR                0x00000003
#define NVA097_SPHV3T2_IMAP_COLOR_DIFFUSE_RED                      MW(449:448)
#define NVA097_SPHV3T2_IMAP_COLOR_DIFFUSE_RED_UNUSED               0x00000000
#define NVA097_SPHV3T2_IMAP_COLOR_DIFFUSE_RED_CONSTANT             0x00000001
#define NVA097_SPHV3T2_IMAP_COLOR_DIFFUSE_RED_PERSPECTIVE          0x00000002
#define NVA097_SPHV3T2_IMAP_COLOR_DIFFUSE_RED_SCREEN_LINEAR        0x00000003
#define NVA097_SPHV3T2_IMAP_COLOR_DIFFUSE_GREEN                    MW(451:450)
#define NVA097_SPHV3T2_IMAP_COLOR_DIFFUSE_GREEN_UNUSED             0x00000000
#define NVA097_SPHV3T2_IMAP_COLOR_DIFFUSE_GREEN_CONSTANT           0x00000001
#define NVA097_SPHV3T2_IMAP_COLOR_DIFFUSE_GREEN_PERSPECTIVE        0x00000002
#define NVA097_SPHV3T2_IMAP_COLOR_DIFFUSE_GREEN_SCREEN_LINEAR      0x00000003
#define NVA097_SPHV3T2_IMAP_COLOR_DIFFUSE_BLUE                     MW(453:452)
#define NVA097_SPHV3T2_IMAP_COLOR_DIFFUSE_BLUE_UNUSED              0x00000000
#define NVA097_SPHV3T2_IMAP_COLOR_DIFFUSE_BLUE_CONSTANT            0x00000001
#define NVA097_SPHV3T2_IMAP_COLOR_DIFFUSE_BLUE_PERSPECTIVE         0x00000002
#define NVA097_SPHV3T2_IMAP_COLOR_DIFFUSE_BLUE_SCREEN_LINEAR       0x00000003
#define NVA097_SPHV3T2_IMAP_COLOR_DIFFUSE_ALPHA                    MW(455:454)
#define NVA097_SPHV3T2_IMAP_COLOR_DIFFUSE_ALPHA_UNUSED             0x00000000
#define NVA097_SPHV3T2_IMAP_COLOR_DIFFUSE_ALPHA_CONSTANT           0x00000001
#define NVA097_SPHV3T2_IMAP_COLOR_DIFFUSE_ALPHA_PERSPECTIVE        0x00000002
#define NVA097_SPHV3T2_IMAP_COLOR_DIFFUSE_ALPHA_SCREEN_LINEAR      0x00000003
#define NVA097_SPHV3T2_IMAP_COLOR_SPECULAR_RED                     MW(457:456)
#define NVA097_SPHV3T2_IMAP_COLOR_SPECULAR_RED_UNUSED              0x00000000
#define NVA097_SPHV3T2_IMAP_COLOR_SPECULAR_RED_CONSTANT            0x00000001
#define NVA097_SPHV3T2_IMAP_COLOR_SPECULAR_RED_PERSPECTIVE         0x00000002
#define NVA097_SPHV3T2_IMAP_COLOR_SPECULAR_RED_SCREEN_LINEAR       0x00000003
#define NVA097_SPHV3T2_IMAP_COLOR_SPECULAR_GREEN                   MW(459:458)
#define NVA097_SPHV3T2_IMAP_COLOR_SPECULAR_GREEN_UNUSED            0x00000000
#define NVA097_SPHV3T2_IMAP_COLOR_SPECULAR_GREEN_CONSTANT          0x00000001
#define NVA097_SPHV3T2_IMAP_COLOR_SPECULAR_GREEN_PERSPECTIVE       0x00000002
#define NVA097_SPHV3T2_IMAP_COLOR_SPECULAR_GREEN_SCREEN_LINEAR     0x00000003
#define NVA097_SPHV3T2_IMAP_COLOR_SPECULAR_BLUE                    MW(461:460)
#define NVA097_SPHV3T2_IMAP_COLOR_SPECULAR_BLUE_UNUSED             0x00000000
#define NVA097_SPHV3T2_IMAP_COLOR_SPECULAR_BLUE_CONSTANT           0x00000001
#define NVA097_SPHV3T2_IMAP_COLOR_SPECULAR_BLUE_PERSPECTIVE        0x00000002
#define NVA097_SPHV3T2_IMAP_COLOR_SPECULAR_BLUE_SCREEN_LINEAR      0x00000003
#define NVA097_SPHV3T2_IMAP_COLOR_SPECULAR_ALPHA                   MW(463:462)
#define NVA097_SPHV3T2_IMAP_COLOR_SPECULAR_ALPHA_UNUSED            0x00000000
#define NVA097_SPHV3T2_IMAP_COLOR_SPECULAR_ALPHA_CONSTANT          0x00000001
#define NVA097_SPHV3T2_IMAP_COLOR_SPECULAR_ALPHA_PERSPECTIVE       0x00000002
#define NVA097_SPHV3T2_IMAP_COLOR_SPECULAR_ALPHA_SCREEN_LINEAR     0x00000003
#define NVA097_SPHV3T2_IMAP_CLIP_DISTANCE0                         MW(464:464)
#define NVA097_SPHV3T2_IMAP_CLIP_DISTANCE0_FALSE                   0x00000000
#define NVA097_SPHV3T2_IMAP_CLIP_DISTANCE0_TRUE                    0x00000001
#define NVA097_SPHV3T2_IMAP_CLIP_DISTANCE1                         MW(465:465)
#define NVA097_SPHV3T2_IMAP_CLIP_DISTANCE1_FALSE                   0x00000000
#define NVA097_SPHV3T2_IMAP_CLIP_DISTANCE1_TRUE                    0x00000001
#define NVA097_SPHV3T2_IMAP_CLIP_DISTANCE2                         MW(466:466)
#define NVA097_SPHV3T2_IMAP_CLIP_DISTANCE2_FALSE                   0x00000000
#define NVA097_SPHV3T2_IMAP_CLIP_DISTANCE2_TRUE                    0x00000001
#define NVA097_SPHV3T2_IMAP_CLIP_DISTANCE3                         MW(467:467)
#define NVA097_SPHV3T2_IMAP_CLIP_DISTANCE3_FALSE                   0x00000000
#define NVA097_SPHV3T2_IMAP_CLIP_DISTANCE3_TRUE                    0x00000001
#define NVA097_SPHV3T2_IMAP_CLIP_DISTANCE4                         MW(468:468)
#define NVA097_SPHV3T2_IMAP_CLIP_DISTANCE4_FALSE                   0x00000000
#define NVA097_SPHV3T2_IMAP_CLIP_DISTANCE4_TRUE                    0x00000001
#define NVA097_SPHV3T2_IMAP_CLIP_DISTANCE5                         MW(469:469)
#define NVA097_SPHV3T2_IMAP_CLIP_DISTANCE5_FALSE                   0x00000000
#define NVA097_SPHV3T2_IMAP_CLIP_DISTANCE5_TRUE                    0x00000001
#define NVA097_SPHV3T2_IMAP_CLIP_DISTANCE6                         MW(470:470)
#define NVA097_SPHV3T2_IMAP_CLIP_DISTANCE6_FALSE                   0x00000000
#define NVA097_SPHV3T2_IMAP_CLIP_DISTANCE6_TRUE                    0x00000001
#define NVA097_SPHV3T2_IMAP_CLIP_DISTANCE7                         MW(471:471)
#define NVA097_SPHV3T2_IMAP_CLIP_DISTANCE7_FALSE                   0x00000000
#define NVA097_SPHV3T2_IMAP_CLIP_DISTANCE7_TRUE                    0x00000001
#define NVA097_SPHV3T2_IMAP_POINT_SPRITE_S                         MW(472:472)
#define NVA097_SPHV3T2_IMAP_POINT_SPRITE_S_FALSE                   0x00000000
#define NVA097_SPHV3T2_IMAP_POINT_SPRITE_S_TRUE                    0x00000001
#define NVA097_SPHV3T2_IMAP_POINT_SPRITE_T                         MW(473:473)
#define NVA097_SPHV3T2_IMAP_POINT_SPRITE_T_FALSE                   0x00000000
#define NVA097_SPHV3T2_IMAP_POINT_SPRITE_T_TRUE                    0x00000001
#define NVA097_SPHV3T2_IMAP_FOG_COORDINATE                         MW(474:474)
#define NVA097_SPHV3T2_IMAP_FOG_COORDINATE_FALSE                   0x00000000
#define NVA097_SPHV3T2_IMAP_FOG_COORDINATE_TRUE                    0x00000001
#define NVA097_SPHV3T2_IMAP_TESSELLATION_EVALUATION_POINT_U        MW(476:476)
#define NVA097_SPHV3T2_IMAP_TESSELLATION_EVALUATION_POINT_U_FALSE  0x00000000
#define NVA097_SPHV3T2_IMAP_TESSELLATION_EVALUATION_POINT_U_TRUE   0x00000001
#define NVA097_SPHV3T2_IMAP_TESSELLATION_EVALUATION_POINT_V        MW(477:477)
#define NVA097_SPHV3T2_IMAP_TESSELLATION_EVALUATION_POINT_V_FALSE  0x00000000
#define NVA097_SPHV3T2_IMAP_TESSELLATION_EVALUATION_POINT_V_TRUE   0x00000001
#define NVA097_SPHV3T2_IMAP_INSTANCE_ID                            MW(478:478)
#define NVA097_SPHV3T2_IMAP_INSTANCE_ID_FALSE                      0x00000000
#define NVA097_SPHV3T2_IMAP_INSTANCE_ID_TRUE                       0x00000001
#define NVA097_SPHV3T2_IMAP_VERTEX_ID                              MW(479:479)
#define NVA097_SPHV3T2_IMAP_VERTEX_ID_FALSE                        0x00000000
#define NVA097_SPHV3T2_IMAP_VERTEX_ID_TRUE                         0x00000001
#define NVA097_SPHV3T2_TEX_IMAP_S(i)                               MW((481+(i)*8):(480+(i)*8))
#define NVA097_SPHV3T2_TEX_IMAP_S_UNUSED                           0x00000000
#define NVA097_SPHV3T2_TEX_IMAP_S_CONSTANT                         0x00000001
#define NVA097_SPHV3T2_TEX_IMAP_S_PERSPECTIVE                      0x00000002
#define NVA097_SPHV3T2_TEX_IMAP_S_SCREEN_LINEAR                    0x00000003
#define NVA097_SPHV3T2_TEX_IMAP_T(i)                               MW((483+(i)*8):(482+(i)*8))
#define NVA097_SPHV3T2_TEX_IMAP_T_UNUSED                           0x00000000
#define NVA097_SPHV3T2_TEX_IMAP_T_CONSTANT                         0x00000001
#define NVA097_SPHV3T2_TEX_IMAP_T_PERSPECTIVE                      0x00000002
#define NVA097_SPHV3T2_TEX_IMAP_T_SCREEN_LINEAR                    0x00000003
#define NVA097_SPHV3T2_TEX_IMAP_R(i)                               MW((485+(i)*8):(484+(i)*8))
#define NVA097_SPHV3T2_TEX_IMAP_R_UNUSED                           0x00000000
#define NVA097_SPHV3T2_TEX_IMAP_R_CONSTANT                         0x00000001
#define NVA097_SPHV3T2_TEX_IMAP_R_PERSPECTIVE                      0x00000002
#define NVA097_SPHV3T2_TEX_IMAP_R_SCREEN_LINEAR                    0x00000003
#define NVA097_SPHV3T2_TEX_IMAP_Q(i)                               MW((487+(i)*8):(486+(i)*8))
#define NVA097_SPHV3T2_TEX_IMAP_Q_UNUSED                           0x00000000
#define NVA097_SPHV3T2_TEX_IMAP_Q_CONSTANT                         0x00000001
#define NVA097_SPHV3T2_TEX_IMAP_Q_PERSPECTIVE                      0x00000002
#define NVA097_SPHV3T2_TEX_IMAP_Q_SCREEN_LINEAR                    0x00000003
#define NVA097_SPHV3T2_OMAP_RED(i)                                 MW((576+(i)*4):(576+(i)*4))
#define NVA097_SPHV3T2_OMAP_RED_FALSE                              0x00000000
#define NVA097_SPHV3T2_OMAP_RED_TRUE                               0x00000001
#define NVA097_SPHV3T2_OMAP_GREEN(i)                               MW((577+(i)*4):(577+(i)*4))
#define NVA097_SPHV3T2_OMAP_GREEN_FALSE                            0x00000000
#define NVA097_SPHV3T2_OMAP_GREEN_TRUE                             0x00000001
#define NVA097_SPHV3T2_OMAP_BLUE(i)                                MW((578+(i)*4):(578+(i)*4))
#define NVA097_SPHV3T2_OMAP_BLUE_FALSE                             0x00000000
#define NVA097_SPHV3T2_OMAP_BLUE_TRUE                              0x00000001
#define NVA097_SPHV3T2_OMAP_ALPHA(i)                               MW((579+(i)*4):(579+(i)*4))
#define NVA097_SPHV3T2_OMAP_ALPHA_FALSE                            0x00000000
#define NVA097_SPHV3T2_OMAP_ALPHA_TRUE                             0x00000001
#define NVA097_SPHV3T2_OMAP_SAMPLE_MASK                            MW(608:608)
#define NVA097_SPHV3T2_OMAP_SAMPLE_MASK_FALSE                      0x00000000
#define NVA097_SPHV3T2_OMAP_SAMPLE_MASK_TRUE                       0x00000001
#define NVA097_SPHV3T2_OMAP_DEPTH                                  MW(609:609)
#define NVA097_SPHV3T2_OMAP_DEPTH_FALSE                            0x00000000
#define NVA097_SPHV3T2_OMAP_DEPTH_TRUE                             0x00000001
#define NVA097_SPHV3T2_RESERVED(i)                                 MW((610+(i)*1):(610+(i)*1))



#endif // #ifndef __CLA097SPH_H__
