/*
 * SPDX-FileCopyrightText: Copyright (c) 2003-2021 NVIDIA CORPORATION & AFFILIATES. All rights reserved.
 * SPDX-License-Identifier: MIT
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */
/* AUTO GENERATED FILE -- DO NOT EDIT */

#ifndef __CLCB97SPH_H__
#define __CLCB97SPH_H__

/*
** Shader Program Header State, Version 4, Type 1
 */

#define NVCB97_SPHV4T1_SPH_TYPE                                    MW(4:0)
#define NVCB97_SPHV4T1_SPH_TYPE_TYPE_01_VTG                        0x00000001
#define NVCB97_SPHV4T1_SPH_TYPE_TYPE_02_PS                         0x00000002
#define NVCB97_SPHV4T1_VERSION                                     MW(9:5)
#define NVCB97_SPHV4T1_SHADER_TYPE                                 MW(13:10)
#define NVCB97_SPHV4T1_SHADER_TYPE_VERTEX                          0x00000001
#define NVCB97_SPHV4T1_SHADER_TYPE_TESSELLATION_INIT               0x00000002
#define NVCB97_SPHV4T1_SHADER_TYPE_TESSELLATION                    0x00000003
#define NVCB97_SPHV4T1_SHADER_TYPE_GEOMETRY                        0x00000004
#define NVCB97_SPHV4T1_SHADER_TYPE_PIXEL                           0x00000005
#define NVCB97_SPHV4T1_MRT_ENABLE                                  MW(14:14)
#define NVCB97_SPHV4T1_MRT_ENABLE_FALSE                            0x00000000
#define NVCB97_SPHV4T1_MRT_ENABLE_TRUE                             0x00000001
#define NVCB97_SPHV4T1_KILLS_PIXELS                                MW(15:15)
#define NVCB97_SPHV4T1_KILLS_PIXELS_FALSE                          0x00000000
#define NVCB97_SPHV4T1_KILLS_PIXELS_TRUE                           0x00000001
#define NVCB97_SPHV4T1_DOES_GLOBAL_STORE                           MW(16:16)
#define NVCB97_SPHV4T1_DOES_GLOBAL_STORE_FALSE                     0x00000000
#define NVCB97_SPHV4T1_DOES_GLOBAL_STORE_TRUE                      0x00000001
#define NVCB97_SPHV4T1_SASS_VERSION                                MW(20:17)
#define NVCB97_SPHV4T1_RESERVED_COMMON_A                           MW(22:22)
#define NVCB97_SPHV4T1_RESERVED_COMMON_B                           MW(27:26)
#define NVCB97_SPHV4T1_STREAM_OUT_MASK                             MW(31:28)
#define NVCB97_SPHV4T1_SHADER_LOCAL_MEMORY_LOW_SIZE                MW(55:32)
#define NVCB97_SPHV4T1_PER_PATCH_ATTRIBUTE_COUNT                   MW(63:56)
#define NVCB97_SPHV4T1_SHADER_LOCAL_MEMORY_HIGH_SIZE               MW(87:64)
#define NVCB97_SPHV4T1_THREADS_PER_INPUT_PRIMITIVE                 MW(95:88)
#define NVCB97_SPHV4T1_RESERVED_COMMON_C                           MW(119:96)
#define NVCB97_SPHV4T1_OUTPUT_TOPOLOGY                             MW(123:120)
#define NVCB97_SPHV4T1_OUTPUT_TOPOLOGY_POINTLIST                   0x00000001
#define NVCB97_SPHV4T1_OUTPUT_TOPOLOGY_LINESTRIP                   0x00000006
#define NVCB97_SPHV4T1_OUTPUT_TOPOLOGY_TRIANGLESTRIP               0x00000007
#define NVCB97_SPHV4T1_MAX_OUTPUT_VERTEX_COUNT                     MW(139:128)
#define NVCB97_SPHV4T1_STORE_REQ_START                             MW(147:140)
#define NVCB97_SPHV4T1_STORE_REQ_END                               MW(159:152)
#define NVCB97_SPHV4T1_IMAP_VPRS_TABLE_INDEX                       MW(183:183)
#define NVCB97_SPHV4T1_IMAP_VPRS_TABLE_INDEX_FALSE                 0x00000000
#define NVCB97_SPHV4T1_IMAP_VPRS_TABLE_INDEX_TRUE                  0x00000001
#define NVCB97_SPHV4T1_IMAP_PRIMITIVE_ID                           MW(184:184)
#define NVCB97_SPHV4T1_IMAP_PRIMITIVE_ID_FALSE                     0x00000000
#define NVCB97_SPHV4T1_IMAP_PRIMITIVE_ID_TRUE                      0x00000001
#define NVCB97_SPHV4T1_IMAP_RT_ARRAY_INDEX                         MW(185:185)
#define NVCB97_SPHV4T1_IMAP_RT_ARRAY_INDEX_FALSE                   0x00000000
#define NVCB97_SPHV4T1_IMAP_RT_ARRAY_INDEX_TRUE                    0x00000001
#define NVCB97_SPHV4T1_IMAP_VIEWPORT_INDEX                         MW(186:186)
#define NVCB97_SPHV4T1_IMAP_VIEWPORT_INDEX_FALSE                   0x00000000
#define NVCB97_SPHV4T1_IMAP_VIEWPORT_INDEX_TRUE                    0x00000001
#define NVCB97_SPHV4T1_IMAP_POINT_SIZE                             MW(187:187)
#define NVCB97_SPHV4T1_IMAP_POINT_SIZE_FALSE                       0x00000000
#define NVCB97_SPHV4T1_IMAP_POINT_SIZE_TRUE                        0x00000001
#define NVCB97_SPHV4T1_IMAP_POSITION_X                             MW(188:188)
#define NVCB97_SPHV4T1_IMAP_POSITION_X_FALSE                       0x00000000
#define NVCB97_SPHV4T1_IMAP_POSITION_X_TRUE                        0x00000001
#define NVCB97_SPHV4T1_IMAP_POSITION_Y                             MW(189:189)
#define NVCB97_SPHV4T1_IMAP_POSITION_Y_FALSE                       0x00000000
#define NVCB97_SPHV4T1_IMAP_POSITION_Y_TRUE                        0x00000001
#define NVCB97_SPHV4T1_IMAP_POSITION_Z                             MW(190:190)
#define NVCB97_SPHV4T1_IMAP_POSITION_Z_FALSE                       0x00000000
#define NVCB97_SPHV4T1_IMAP_POSITION_Z_TRUE                        0x00000001
#define NVCB97_SPHV4T1_IMAP_POSITION_W                             MW(191:191)
#define NVCB97_SPHV4T1_IMAP_POSITION_W_FALSE                       0x00000000
#define NVCB97_SPHV4T1_IMAP_POSITION_W_TRUE                        0x00000001
#define NVCB97_SPHV4T1_GENERIC_IMAP_X(i)                           MW((192+(i)*4):(192+(i)*4))
#define NVCB97_SPHV4T1_GENERIC_IMAP_X_FALSE                        0x00000000
#define NVCB97_SPHV4T1_GENERIC_IMAP_X_TRUE                         0x00000001
#define NVCB97_SPHV4T1_GENERIC_IMAP_Y(i)                           MW((193+(i)*4):(193+(i)*4))
#define NVCB97_SPHV4T1_GENERIC_IMAP_Y_FALSE                        0x00000000
#define NVCB97_SPHV4T1_GENERIC_IMAP_Y_TRUE                         0x00000001
#define NVCB97_SPHV4T1_GENERIC_IMAP_Z(i)                           MW((194+(i)*4):(194+(i)*4))
#define NVCB97_SPHV4T1_GENERIC_IMAP_Z_FALSE                        0x00000000
#define NVCB97_SPHV4T1_GENERIC_IMAP_Z_TRUE                         0x00000001
#define NVCB97_SPHV4T1_GENERIC_IMAP_W(i)                           MW((195+(i)*4):(195+(i)*4))
#define NVCB97_SPHV4T1_GENERIC_IMAP_W_FALSE                        0x00000000
#define NVCB97_SPHV4T1_GENERIC_IMAP_W_TRUE                         0x00000001
#define NVCB97_SPHV4T1_IMAP_COLOR_FRONT_DIFFUSE_RED                MW(320:320)
#define NVCB97_SPHV4T1_IMAP_COLOR_FRONT_DIFFUSE_RED_FALSE          0x00000000
#define NVCB97_SPHV4T1_IMAP_COLOR_FRONT_DIFFUSE_RED_TRUE           0x00000001
#define NVCB97_SPHV4T1_IMAP_COLOR_FRONT_DIFFUSE_GREEN              MW(321:321)
#define NVCB97_SPHV4T1_IMAP_COLOR_FRONT_DIFFUSE_GREEN_FALSE        0x00000000
#define NVCB97_SPHV4T1_IMAP_COLOR_FRONT_DIFFUSE_GREEN_TRUE         0x00000001
#define NVCB97_SPHV4T1_IMAP_COLOR_FRONT_DIFFUSE_BLUE               MW(322:322)
#define NVCB97_SPHV4T1_IMAP_COLOR_FRONT_DIFFUSE_BLUE_FALSE         0x00000000
#define NVCB97_SPHV4T1_IMAP_COLOR_FRONT_DIFFUSE_BLUE_TRUE          0x00000001
#define NVCB97_SPHV4T1_IMAP_COLOR_FRONT_DIFFUSE_ALPHA              MW(323:323)
#define NVCB97_SPHV4T1_IMAP_COLOR_FRONT_DIFFUSE_ALPHA_FALSE        0x00000000
#define NVCB97_SPHV4T1_IMAP_COLOR_FRONT_DIFFUSE_ALPHA_TRUE         0x00000001
#define NVCB97_SPHV4T1_IMAP_COLOR_FRONT_SPECULAR_RED               MW(324:324)
#define NVCB97_SPHV4T1_IMAP_COLOR_FRONT_SPECULAR_RED_FALSE         0x00000000
#define NVCB97_SPHV4T1_IMAP_COLOR_FRONT_SPECULAR_RED_TRUE          0x00000001
#define NVCB97_SPHV4T1_IMAP_COLOR_FRONT_SPECULAR_GREEN             MW(325:325)
#define NVCB97_SPHV4T1_IMAP_COLOR_FRONT_SPECULAR_GREEN_FALSE       0x00000000
#define NVCB97_SPHV4T1_IMAP_COLOR_FRONT_SPECULAR_GREEN_TRUE        0x00000001
#define NVCB97_SPHV4T1_IMAP_COLOR_FRONT_SPECULAR_BLUE              MW(326:326)
#define NVCB97_SPHV4T1_IMAP_COLOR_FRONT_SPECULAR_BLUE_FALSE        0x00000000
#define NVCB97_SPHV4T1_IMAP_COLOR_FRONT_SPECULAR_BLUE_TRUE         0x00000001
#define NVCB97_SPHV4T1_IMAP_COLOR_FRONT_SPECULAR_ALPHA             MW(327:327)
#define NVCB97_SPHV4T1_IMAP_COLOR_FRONT_SPECULAR_ALPHA_FALSE       0x00000000
#define NVCB97_SPHV4T1_IMAP_COLOR_FRONT_SPECULAR_ALPHA_TRUE        0x00000001
#define NVCB97_SPHV4T1_IMAP_COLOR_BACK_DIFFUSE_RED                 MW(328:328)
#define NVCB97_SPHV4T1_IMAP_COLOR_BACK_DIFFUSE_RED_FALSE           0x00000000
#define NVCB97_SPHV4T1_IMAP_COLOR_BACK_DIFFUSE_RED_TRUE            0x00000001
#define NVCB97_SPHV4T1_IMAP_COLOR_BACK_DIFFUSE_GREEN               MW(329:329)
#define NVCB97_SPHV4T1_IMAP_COLOR_BACK_DIFFUSE_GREEN_FALSE         0x00000000
#define NVCB97_SPHV4T1_IMAP_COLOR_BACK_DIFFUSE_GREEN_TRUE          0x00000001
#define NVCB97_SPHV4T1_IMAP_COLOR_BACK_DIFFUSE_BLUE                MW(330:330)
#define NVCB97_SPHV4T1_IMAP_COLOR_BACK_DIFFUSE_BLUE_FALSE          0x00000000
#define NVCB97_SPHV4T1_IMAP_COLOR_BACK_DIFFUSE_BLUE_TRUE           0x00000001
#define NVCB97_SPHV4T1_IMAP_COLOR_BACK_DIFFUSE_ALPHA               MW(331:331)
#define NVCB97_SPHV4T1_IMAP_COLOR_BACK_DIFFUSE_ALPHA_FALSE         0x00000000
#define NVCB97_SPHV4T1_IMAP_COLOR_BACK_DIFFUSE_ALPHA_TRUE          0x00000001
#define NVCB97_SPHV4T1_IMAP_COLOR_BACK_SPECULAR_RED                MW(332:332)
#define NVCB97_SPHV4T1_IMAP_COLOR_BACK_SPECULAR_RED_FALSE          0x00000000
#define NVCB97_SPHV4T1_IMAP_COLOR_BACK_SPECULAR_RED_TRUE           0x00000001
#define NVCB97_SPHV4T1_IMAP_COLOR_BACK_SPECULAR_GREEN              MW(333:333)
#define NVCB97_SPHV4T1_IMAP_COLOR_BACK_SPECULAR_GREEN_FALSE        0x00000000
#define NVCB97_SPHV4T1_IMAP_COLOR_BACK_SPECULAR_GREEN_TRUE         0x00000001
#define NVCB97_SPHV4T1_IMAP_COLOR_BACK_SPECULAR_BLUE               MW(334:334)
#define NVCB97_SPHV4T1_IMAP_COLOR_BACK_SPECULAR_BLUE_FALSE         0x00000000
#define NVCB97_SPHV4T1_IMAP_COLOR_BACK_SPECULAR_BLUE_TRUE          0x00000001
#define NVCB97_SPHV4T1_IMAP_COLOR_BACK_SPECULAR_ALPHA              MW(335:335)
#define NVCB97_SPHV4T1_IMAP_COLOR_BACK_SPECULAR_ALPHA_FALSE        0x00000000
#define NVCB97_SPHV4T1_IMAP_COLOR_BACK_SPECULAR_ALPHA_TRUE         0x00000001
#define NVCB97_SPHV4T1_IMAP_CLIP_DISTANCE0                         MW(336:336)
#define NVCB97_SPHV4T1_IMAP_CLIP_DISTANCE0_FALSE                   0x00000000
#define NVCB97_SPHV4T1_IMAP_CLIP_DISTANCE0_TRUE                    0x00000001
#define NVCB97_SPHV4T1_IMAP_CLIP_DISTANCE1                         MW(337:337)
#define NVCB97_SPHV4T1_IMAP_CLIP_DISTANCE1_FALSE                   0x00000000
#define NVCB97_SPHV4T1_IMAP_CLIP_DISTANCE1_TRUE                    0x00000001
#define NVCB97_SPHV4T1_IMAP_CLIP_DISTANCE2                         MW(338:338)
#define NVCB97_SPHV4T1_IMAP_CLIP_DISTANCE2_FALSE                   0x00000000
#define NVCB97_SPHV4T1_IMAP_CLIP_DISTANCE2_TRUE                    0x00000001
#define NVCB97_SPHV4T1_IMAP_CLIP_DISTANCE3                         MW(339:339)
#define NVCB97_SPHV4T1_IMAP_CLIP_DISTANCE3_FALSE                   0x00000000
#define NVCB97_SPHV4T1_IMAP_CLIP_DISTANCE3_TRUE                    0x00000001
#define NVCB97_SPHV4T1_IMAP_CLIP_DISTANCE4                         MW(340:340)
#define NVCB97_SPHV4T1_IMAP_CLIP_DISTANCE4_FALSE                   0x00000000
#define NVCB97_SPHV4T1_IMAP_CLIP_DISTANCE4_TRUE                    0x00000001
#define NVCB97_SPHV4T1_IMAP_CLIP_DISTANCE5                         MW(341:341)
#define NVCB97_SPHV4T1_IMAP_CLIP_DISTANCE5_FALSE                   0x00000000
#define NVCB97_SPHV4T1_IMAP_CLIP_DISTANCE5_TRUE                    0x00000001
#define NVCB97_SPHV4T1_IMAP_CLIP_DISTANCE6                         MW(342:342)
#define NVCB97_SPHV4T1_IMAP_CLIP_DISTANCE6_FALSE                   0x00000000
#define NVCB97_SPHV4T1_IMAP_CLIP_DISTANCE6_TRUE                    0x00000001
#define NVCB97_SPHV4T1_IMAP_CLIP_DISTANCE7                         MW(343:343)
#define NVCB97_SPHV4T1_IMAP_CLIP_DISTANCE7_FALSE                   0x00000000
#define NVCB97_SPHV4T1_IMAP_CLIP_DISTANCE7_TRUE                    0x00000001
#define NVCB97_SPHV4T1_IMAP_POINT_SPRITE_S                         MW(344:344)
#define NVCB97_SPHV4T1_IMAP_POINT_SPRITE_S_FALSE                   0x00000000
#define NVCB97_SPHV4T1_IMAP_POINT_SPRITE_S_TRUE                    0x00000001
#define NVCB97_SPHV4T1_IMAP_POINT_SPRITE_T                         MW(345:345)
#define NVCB97_SPHV4T1_IMAP_POINT_SPRITE_T_FALSE                   0x00000000
#define NVCB97_SPHV4T1_IMAP_POINT_SPRITE_T_TRUE                    0x00000001
#define NVCB97_SPHV4T1_IMAP_FOG_COORDINATE                         MW(346:346)
#define NVCB97_SPHV4T1_IMAP_FOG_COORDINATE_FALSE                   0x00000000
#define NVCB97_SPHV4T1_IMAP_FOG_COORDINATE_TRUE                    0x00000001
#define NVCB97_SPHV4T1_IMAP_TESSELLATION_EVALUATION_POINT_U        MW(348:348)
#define NVCB97_SPHV4T1_IMAP_TESSELLATION_EVALUATION_POINT_U_FALSE  0x00000000
#define NVCB97_SPHV4T1_IMAP_TESSELLATION_EVALUATION_POINT_U_TRUE   0x00000001
#define NVCB97_SPHV4T1_IMAP_TESSELLATION_EVALUATION_POINT_V        MW(349:349)
#define NVCB97_SPHV4T1_IMAP_TESSELLATION_EVALUATION_POINT_V_FALSE  0x00000000
#define NVCB97_SPHV4T1_IMAP_TESSELLATION_EVALUATION_POINT_V_TRUE   0x00000001
#define NVCB97_SPHV4T1_IMAP_INSTANCE_ID                            MW(350:350)
#define NVCB97_SPHV4T1_IMAP_INSTANCE_ID_FALSE                      0x00000000
#define NVCB97_SPHV4T1_IMAP_INSTANCE_ID_TRUE                       0x00000001
#define NVCB97_SPHV4T1_IMAP_VERTEX_ID                              MW(351:351)
#define NVCB97_SPHV4T1_IMAP_VERTEX_ID_FALSE                        0x00000000
#define NVCB97_SPHV4T1_IMAP_VERTEX_ID_TRUE                         0x00000001
#define NVCB97_SPHV4T1_TEX_IMAP_S(i)                               MW((352+(i)*4):(352+(i)*4))
#define NVCB97_SPHV4T1_TEX_IMAP_S_FALSE                            0x00000000
#define NVCB97_SPHV4T1_TEX_IMAP_S_TRUE                             0x00000001
#define NVCB97_SPHV4T1_TEX_IMAP_T(i)                               MW((353+(i)*4):(353+(i)*4))
#define NVCB97_SPHV4T1_TEX_IMAP_T_FALSE                            0x00000000
#define NVCB97_SPHV4T1_TEX_IMAP_T_TRUE                             0x00000001
#define NVCB97_SPHV4T1_TEX_IMAP_R(i)                               MW((354+(i)*4):(354+(i)*4))
#define NVCB97_SPHV4T1_TEX_IMAP_R_FALSE                            0x00000000
#define NVCB97_SPHV4T1_TEX_IMAP_R_TRUE                             0x00000001
#define NVCB97_SPHV4T1_TEX_IMAP_Q(i)                               MW((355+(i)*4):(355+(i)*4))
#define NVCB97_SPHV4T1_TEX_IMAP_Q_FALSE                            0x00000000
#define NVCB97_SPHV4T1_TEX_IMAP_Q_TRUE                             0x00000001
#define NVCB97_SPHV4T1_IMAP_VIEWPORT_MASK                          MW(392:392)
#define NVCB97_SPHV4T1_IMAP_VIEWPORT_MASK_FALSE                    0x00000000
#define NVCB97_SPHV4T1_IMAP_VIEWPORT_MASK_TRUE                     0x00000001
#define NVCB97_SPHV4T1_IMAP_VIEWPORT_MASK2                         MW(393:393)
#define NVCB97_SPHV4T1_IMAP_VIEWPORT_MASK2_FALSE                   0x00000000
#define NVCB97_SPHV4T1_IMAP_VIEWPORT_MASK2_TRUE                    0x00000001
#define NVCB97_SPHV4T1_IMAP_BARYCENTRIC0                           MW(394:394)
#define NVCB97_SPHV4T1_IMAP_BARYCENTRIC0_FALSE                     0x00000000
#define NVCB97_SPHV4T1_IMAP_BARYCENTRIC0_TRUE                      0x00000001
#define NVCB97_SPHV4T1_IMAP_BARYCENTRIC1                           MW(395:395)
#define NVCB97_SPHV4T1_IMAP_BARYCENTRIC1_FALSE                     0x00000000
#define NVCB97_SPHV4T1_IMAP_BARYCENTRIC1_TRUE                      0x00000001
#define NVCB97_SPHV4T1_IMAP_BARYCENTRIC2                           MW(396:396)
#define NVCB97_SPHV4T1_IMAP_BARYCENTRIC2_FALSE                     0x00000000
#define NVCB97_SPHV4T1_IMAP_BARYCENTRIC2_TRUE                      0x00000001
#define NVCB97_SPHV4T1_IMAP_BARYCENTRIC0_W                         MW(397:397)
#define NVCB97_SPHV4T1_IMAP_BARYCENTRIC0_W_FALSE                   0x00000000
#define NVCB97_SPHV4T1_IMAP_BARYCENTRIC0_W_TRUE                    0x00000001
#define NVCB97_SPHV4T1_IMAP_BARYCENTRIC1_W                         MW(398:398)
#define NVCB97_SPHV4T1_IMAP_BARYCENTRIC1_W_FALSE                   0x00000000
#define NVCB97_SPHV4T1_IMAP_BARYCENTRIC1_W_TRUE                    0x00000001
#define NVCB97_SPHV4T1_IMAP_BARYCENTRIC2_W                         MW(399:399)
#define NVCB97_SPHV4T1_IMAP_BARYCENTRIC2_W_FALSE                   0x00000000
#define NVCB97_SPHV4T1_IMAP_BARYCENTRIC2_W_TRUE                    0x00000001
#define NVCB97_SPHV4T1_OMAP_VPRS_TABLE_INDEX                       MW(423:423)
#define NVCB97_SPHV4T1_OMAP_VPRS_TABLE_INDEX_FALSE                 0x00000000
#define NVCB97_SPHV4T1_OMAP_VPRS_TABLE_INDEX_TRUE                  0x00000001
#define NVCB97_SPHV4T1_OMAP_PRIMITIVE_ID                           MW(424:424)
#define NVCB97_SPHV4T1_OMAP_PRIMITIVE_ID_FALSE                     0x00000000
#define NVCB97_SPHV4T1_OMAP_PRIMITIVE_ID_TRUE                      0x00000001
#define NVCB97_SPHV4T1_OMAP_RT_ARRAY_INDEX                         MW(425:425)
#define NVCB97_SPHV4T1_OMAP_RT_ARRAY_INDEX_FALSE                   0x00000000
#define NVCB97_SPHV4T1_OMAP_RT_ARRAY_INDEX_TRUE                    0x00000001
#define NVCB97_SPHV4T1_OMAP_VIEWPORT_INDEX                         MW(426:426)
#define NVCB97_SPHV4T1_OMAP_VIEWPORT_INDEX_FALSE                   0x00000000
#define NVCB97_SPHV4T1_OMAP_VIEWPORT_INDEX_TRUE                    0x00000001
#define NVCB97_SPHV4T1_OMAP_POINT_SIZE                             MW(427:427)
#define NVCB97_SPHV4T1_OMAP_POINT_SIZE_FALSE                       0x00000000
#define NVCB97_SPHV4T1_OMAP_POINT_SIZE_TRUE                        0x00000001
#define NVCB97_SPHV4T1_OMAP_POSITION_X                             MW(428:428)
#define NVCB97_SPHV4T1_OMAP_POSITION_X_FALSE                       0x00000000
#define NVCB97_SPHV4T1_OMAP_POSITION_X_TRUE                        0x00000001
#define NVCB97_SPHV4T1_OMAP_POSITION_Y                             MW(429:429)
#define NVCB97_SPHV4T1_OMAP_POSITION_Y_FALSE                       0x00000000
#define NVCB97_SPHV4T1_OMAP_POSITION_Y_TRUE                        0x00000001
#define NVCB97_SPHV4T1_OMAP_POSITION_Z                             MW(430:430)
#define NVCB97_SPHV4T1_OMAP_POSITION_Z_FALSE                       0x00000000
#define NVCB97_SPHV4T1_OMAP_POSITION_Z_TRUE                        0x00000001
#define NVCB97_SPHV4T1_OMAP_POSITION_W                             MW(431:431)
#define NVCB97_SPHV4T1_OMAP_POSITION_W_FALSE                       0x00000000
#define NVCB97_SPHV4T1_OMAP_POSITION_W_TRUE                        0x00000001
#define NVCB97_SPHV4T1_GENERIC_OMAP_X(i)                           MW((432+(i)*4):(432+(i)*4))
#define NVCB97_SPHV4T1_GENERIC_OMAP_X_FALSE                        0x00000000
#define NVCB97_SPHV4T1_GENERIC_OMAP_X_TRUE                         0x00000001
#define NVCB97_SPHV4T1_GENERIC_OMAP_Y(i)                           MW((433+(i)*4):(433+(i)*4))
#define NVCB97_SPHV4T1_GENERIC_OMAP_Y_FALSE                        0x00000000
#define NVCB97_SPHV4T1_GENERIC_OMAP_Y_TRUE                         0x00000001
#define NVCB97_SPHV4T1_GENERIC_OMAP_Z(i)                           MW((434+(i)*4):(434+(i)*4))
#define NVCB97_SPHV4T1_GENERIC_OMAP_Z_FALSE                        0x00000000
#define NVCB97_SPHV4T1_GENERIC_OMAP_Z_TRUE                         0x00000001
#define NVCB97_SPHV4T1_GENERIC_OMAP_W(i)                           MW((435+(i)*4):(435+(i)*4))
#define NVCB97_SPHV4T1_GENERIC_OMAP_W_FALSE                        0x00000000
#define NVCB97_SPHV4T1_GENERIC_OMAP_W_TRUE                         0x00000001
#define NVCB97_SPHV4T1_OMAP_COLOR_FRONT_DIFFUSE_RED                MW(560:560)
#define NVCB97_SPHV4T1_OMAP_COLOR_FRONT_DIFFUSE_RED_FALSE          0x00000000
#define NVCB97_SPHV4T1_OMAP_COLOR_FRONT_DIFFUSE_RED_TRUE           0x00000001
#define NVCB97_SPHV4T1_OMAP_COLOR_FRONT_DIFFUSE_GREEN              MW(561:561)
#define NVCB97_SPHV4T1_OMAP_COLOR_FRONT_DIFFUSE_GREEN_FALSE        0x00000000
#define NVCB97_SPHV4T1_OMAP_COLOR_FRONT_DIFFUSE_GREEN_TRUE         0x00000001
#define NVCB97_SPHV4T1_OMAP_COLOR_FRONT_DIFFUSE_BLUE               MW(562:562)
#define NVCB97_SPHV4T1_OMAP_COLOR_FRONT_DIFFUSE_BLUE_FALSE         0x00000000
#define NVCB97_SPHV4T1_OMAP_COLOR_FRONT_DIFFUSE_BLUE_TRUE          0x00000001
#define NVCB97_SPHV4T1_OMAP_COLOR_FRONT_DIFFUSE_ALPHA              MW(563:563)
#define NVCB97_SPHV4T1_OMAP_COLOR_FRONT_DIFFUSE_ALPHA_FALSE        0x00000000
#define NVCB97_SPHV4T1_OMAP_COLOR_FRONT_DIFFUSE_ALPHA_TRUE         0x00000001
#define NVCB97_SPHV4T1_OMAP_COLOR_FRONT_SPECULAR_RED               MW(564:564)
#define NVCB97_SPHV4T1_OMAP_COLOR_FRONT_SPECULAR_RED_FALSE         0x00000000
#define NVCB97_SPHV4T1_OMAP_COLOR_FRONT_SPECULAR_RED_TRUE          0x00000001
#define NVCB97_SPHV4T1_OMAP_COLOR_FRONT_SPECULAR_GREEN             MW(565:565)
#define NVCB97_SPHV4T1_OMAP_COLOR_FRONT_SPECULAR_GREEN_FALSE       0x00000000
#define NVCB97_SPHV4T1_OMAP_COLOR_FRONT_SPECULAR_GREEN_TRUE        0x00000001
#define NVCB97_SPHV4T1_OMAP_COLOR_FRONT_SPECULAR_BLUE              MW(566:566)
#define NVCB97_SPHV4T1_OMAP_COLOR_FRONT_SPECULAR_BLUE_FALSE        0x00000000
#define NVCB97_SPHV4T1_OMAP_COLOR_FRONT_SPECULAR_BLUE_TRUE         0x00000001
#define NVCB97_SPHV4T1_OMAP_COLOR_FRONT_SPECULAR_ALPHA             MW(567:567)
#define NVCB97_SPHV4T1_OMAP_COLOR_FRONT_SPECULAR_ALPHA_FALSE       0x00000000
#define NVCB97_SPHV4T1_OMAP_COLOR_FRONT_SPECULAR_ALPHA_TRUE        0x00000001
#define NVCB97_SPHV4T1_OMAP_COLOR_BACK_DIFFUSE_RED                 MW(568:568)
#define NVCB97_SPHV4T1_OMAP_COLOR_BACK_DIFFUSE_RED_FALSE           0x00000000
#define NVCB97_SPHV4T1_OMAP_COLOR_BACK_DIFFUSE_RED_TRUE            0x00000001
#define NVCB97_SPHV4T1_OMAP_COLOR_BACK_DIFFUSE_GREEN               MW(569:569)
#define NVCB97_SPHV4T1_OMAP_COLOR_BACK_DIFFUSE_GREEN_FALSE         0x00000000
#define NVCB97_SPHV4T1_OMAP_COLOR_BACK_DIFFUSE_GREEN_TRUE          0x00000001
#define NVCB97_SPHV4T1_OMAP_COLOR_BACK_DIFFUSE_BLUE                MW(570:570)
#define NVCB97_SPHV4T1_OMAP_COLOR_BACK_DIFFUSE_BLUE_FALSE          0x00000000
#define NVCB97_SPHV4T1_OMAP_COLOR_BACK_DIFFUSE_BLUE_TRUE           0x00000001
#define NVCB97_SPHV4T1_OMAP_COLOR_BACK_DIFFUSE_ALPHA               MW(571:571)
#define NVCB97_SPHV4T1_OMAP_COLOR_BACK_DIFFUSE_ALPHA_FALSE         0x00000000
#define NVCB97_SPHV4T1_OMAP_COLOR_BACK_DIFFUSE_ALPHA_TRUE          0x00000001
#define NVCB97_SPHV4T1_OMAP_COLOR_BACK_SPECULAR_RED                MW(572:572)
#define NVCB97_SPHV4T1_OMAP_COLOR_BACK_SPECULAR_RED_FALSE          0x00000000
#define NVCB97_SPHV4T1_OMAP_COLOR_BACK_SPECULAR_RED_TRUE           0x00000001
#define NVCB97_SPHV4T1_OMAP_COLOR_BACK_SPECULAR_GREEN              MW(573:573)
#define NVCB97_SPHV4T1_OMAP_COLOR_BACK_SPECULAR_GREEN_FALSE        0x00000000
#define NVCB97_SPHV4T1_OMAP_COLOR_BACK_SPECULAR_GREEN_TRUE         0x00000001
#define NVCB97_SPHV4T1_OMAP_COLOR_BACK_SPECULAR_BLUE               MW(574:574)
#define NVCB97_SPHV4T1_OMAP_COLOR_BACK_SPECULAR_BLUE_FALSE         0x00000000
#define NVCB97_SPHV4T1_OMAP_COLOR_BACK_SPECULAR_BLUE_TRUE          0x00000001
#define NVCB97_SPHV4T1_OMAP_COLOR_BACK_SPECULAR_ALPHA              MW(575:575)
#define NVCB97_SPHV4T1_OMAP_COLOR_BACK_SPECULAR_ALPHA_FALSE        0x00000000
#define NVCB97_SPHV4T1_OMAP_COLOR_BACK_SPECULAR_ALPHA_TRUE         0x00000001
#define NVCB97_SPHV4T1_OMAP_CLIP_DISTANCE0                         MW(576:576)
#define NVCB97_SPHV4T1_OMAP_CLIP_DISTANCE0_FALSE                   0x00000000
#define NVCB97_SPHV4T1_OMAP_CLIP_DISTANCE0_TRUE                    0x00000001
#define NVCB97_SPHV4T1_OMAP_CLIP_DISTANCE1                         MW(577:577)
#define NVCB97_SPHV4T1_OMAP_CLIP_DISTANCE1_FALSE                   0x00000000
#define NVCB97_SPHV4T1_OMAP_CLIP_DISTANCE1_TRUE                    0x00000001
#define NVCB97_SPHV4T1_OMAP_CLIP_DISTANCE2                         MW(578:578)
#define NVCB97_SPHV4T1_OMAP_CLIP_DISTANCE2_FALSE                   0x00000000
#define NVCB97_SPHV4T1_OMAP_CLIP_DISTANCE2_TRUE                    0x00000001
#define NVCB97_SPHV4T1_OMAP_CLIP_DISTANCE3                         MW(579:579)
#define NVCB97_SPHV4T1_OMAP_CLIP_DISTANCE3_FALSE                   0x00000000
#define NVCB97_SPHV4T1_OMAP_CLIP_DISTANCE3_TRUE                    0x00000001
#define NVCB97_SPHV4T1_OMAP_CLIP_DISTANCE4                         MW(580:580)
#define NVCB97_SPHV4T1_OMAP_CLIP_DISTANCE4_FALSE                   0x00000000
#define NVCB97_SPHV4T1_OMAP_CLIP_DISTANCE4_TRUE                    0x00000001
#define NVCB97_SPHV4T1_OMAP_CLIP_DISTANCE5                         MW(581:581)
#define NVCB97_SPHV4T1_OMAP_CLIP_DISTANCE5_FALSE                   0x00000000
#define NVCB97_SPHV4T1_OMAP_CLIP_DISTANCE5_TRUE                    0x00000001
#define NVCB97_SPHV4T1_OMAP_CLIP_DISTANCE6                         MW(582:582)
#define NVCB97_SPHV4T1_OMAP_CLIP_DISTANCE6_FALSE                   0x00000000
#define NVCB97_SPHV4T1_OMAP_CLIP_DISTANCE6_TRUE                    0x00000001
#define NVCB97_SPHV4T1_OMAP_CLIP_DISTANCE7                         MW(583:583)
#define NVCB97_SPHV4T1_OMAP_CLIP_DISTANCE7_FALSE                   0x00000000
#define NVCB97_SPHV4T1_OMAP_CLIP_DISTANCE7_TRUE                    0x00000001
#define NVCB97_SPHV4T1_OMAP_POINT_SPRITE_S                         MW(584:584)
#define NVCB97_SPHV4T1_OMAP_POINT_SPRITE_S_FALSE                   0x00000000
#define NVCB97_SPHV4T1_OMAP_POINT_SPRITE_S_TRUE                    0x00000001
#define NVCB97_SPHV4T1_OMAP_POINT_SPRITE_T                         MW(585:585)
#define NVCB97_SPHV4T1_OMAP_POINT_SPRITE_T_FALSE                   0x00000000
#define NVCB97_SPHV4T1_OMAP_POINT_SPRITE_T_TRUE                    0x00000001
#define NVCB97_SPHV4T1_OMAP_FOG_COORDINATE                         MW(586:586)
#define NVCB97_SPHV4T1_OMAP_FOG_COORDINATE_FALSE                   0x00000000
#define NVCB97_SPHV4T1_OMAP_FOG_COORDINATE_TRUE                    0x00000001
#define NVCB97_SPHV4T1_OMAP_TESSELLATION_EVALUATION_POINT_U        MW(588:588)
#define NVCB97_SPHV4T1_OMAP_TESSELLATION_EVALUATION_POINT_U_FALSE  0x00000000
#define NVCB97_SPHV4T1_OMAP_TESSELLATION_EVALUATION_POINT_U_TRUE   0x00000001
#define NVCB97_SPHV4T1_OMAP_TESSELLATION_EVALUATION_POINT_V        MW(589:589)
#define NVCB97_SPHV4T1_OMAP_TESSELLATION_EVALUATION_POINT_V_FALSE  0x00000000
#define NVCB97_SPHV4T1_OMAP_TESSELLATION_EVALUATION_POINT_V_TRUE   0x00000001
#define NVCB97_SPHV4T1_OMAP_INSTANCE_ID                            MW(590:590)
#define NVCB97_SPHV4T1_OMAP_INSTANCE_ID_FALSE                      0x00000000
#define NVCB97_SPHV4T1_OMAP_INSTANCE_ID_TRUE                       0x00000001
#define NVCB97_SPHV4T1_OMAP_VERTEX_ID                              MW(591:591)
#define NVCB97_SPHV4T1_OMAP_VERTEX_ID_FALSE                        0x00000000
#define NVCB97_SPHV4T1_OMAP_VERTEX_ID_TRUE                         0x00000001
#define NVCB97_SPHV4T1_TEX_OMAP_S(i)                               MW((592+(i)*4):(592+(i)*4))
#define NVCB97_SPHV4T1_TEX_OMAP_S_FALSE                            0x00000000
#define NVCB97_SPHV4T1_TEX_OMAP_S_TRUE                             0x00000001
#define NVCB97_SPHV4T1_TEX_OMAP_T(i)                               MW((593+(i)*4):(593+(i)*4))
#define NVCB97_SPHV4T1_TEX_OMAP_T_FALSE                            0x00000000
#define NVCB97_SPHV4T1_TEX_OMAP_T_TRUE                             0x00000001
#define NVCB97_SPHV4T1_TEX_OMAP_R(i)                               MW((594+(i)*4):(594+(i)*4))
#define NVCB97_SPHV4T1_TEX_OMAP_R_FALSE                            0x00000000
#define NVCB97_SPHV4T1_TEX_OMAP_R_TRUE                             0x00000001
#define NVCB97_SPHV4T1_TEX_OMAP_Q(i)                               MW((595+(i)*4):(595+(i)*4))
#define NVCB97_SPHV4T1_TEX_OMAP_Q_FALSE                            0x00000000
#define NVCB97_SPHV4T1_TEX_OMAP_Q_TRUE                             0x00000001
#define NVCB97_SPHV4T1_OMAP_VIEWPORT_MASK                          MW(632:632)
#define NVCB97_SPHV4T1_OMAP_VIEWPORT_MASK_FALSE                    0x00000000
#define NVCB97_SPHV4T1_OMAP_VIEWPORT_MASK_TRUE                     0x00000001
#define NVCB97_SPHV4T1_OMAP_VIEWPORT_MASK2                         MW(633:633)
#define NVCB97_SPHV4T1_OMAP_VIEWPORT_MASK2_FALSE                   0x00000000
#define NVCB97_SPHV4T1_OMAP_VIEWPORT_MASK2_TRUE                    0x00000001
#define NVCB97_SPHV4T1_OMAP_BARYCENTRIC0                           MW(634:634)
#define NVCB97_SPHV4T1_OMAP_BARYCENTRIC0_FALSE                     0x00000000
#define NVCB97_SPHV4T1_OMAP_BARYCENTRIC0_TRUE                      0x00000001
#define NVCB97_SPHV4T1_OMAP_BARYCENTRIC1                           MW(635:635)
#define NVCB97_SPHV4T1_OMAP_BARYCENTRIC1_FALSE                     0x00000000
#define NVCB97_SPHV4T1_OMAP_BARYCENTRIC1_TRUE                      0x00000001
#define NVCB97_SPHV4T1_OMAP_BARYCENTRIC2                           MW(636:636)
#define NVCB97_SPHV4T1_OMAP_BARYCENTRIC2_FALSE                     0x00000000
#define NVCB97_SPHV4T1_OMAP_BARYCENTRIC2_TRUE                      0x00000001
#define NVCB97_SPHV4T1_OMAP_BARYCENTRIC0_W                         MW(637:637)
#define NVCB97_SPHV4T1_OMAP_BARYCENTRIC0_W_FALSE                   0x00000000
#define NVCB97_SPHV4T1_OMAP_BARYCENTRIC0_W_TRUE                    0x00000001
#define NVCB97_SPHV4T1_OMAP_BARYCENTRIC1_W                         MW(638:638)
#define NVCB97_SPHV4T1_OMAP_BARYCENTRIC1_W_FALSE                   0x00000000
#define NVCB97_SPHV4T1_OMAP_BARYCENTRIC1_W_TRUE                    0x00000001
#define NVCB97_SPHV4T1_OMAP_BARYCENTRIC2_W                         MW(639:639)
#define NVCB97_SPHV4T1_OMAP_BARYCENTRIC2_W_FALSE                   0x00000000
#define NVCB97_SPHV4T1_OMAP_BARYCENTRIC2_W_TRUE                    0x00000001
#define NVCB97_SPHV4T1_VMAP_VPRS_TABLE_INDEX                       MW(663:663)
#define NVCB97_SPHV4T1_VMAP_VPRS_TABLE_INDEX_FALSE                 0x00000000
#define NVCB97_SPHV4T1_VMAP_VPRS_TABLE_INDEX_TRUE                  0x00000001
#define NVCB97_SPHV4T1_VMAP_PRIMITIVE_ID                           MW(664:664)
#define NVCB97_SPHV4T1_VMAP_PRIMITIVE_ID_FALSE                     0x00000000
#define NVCB97_SPHV4T1_VMAP_PRIMITIVE_ID_TRUE                      0x00000001
#define NVCB97_SPHV4T1_VMAP_RT_ARRAY_INDEX                         MW(665:665)
#define NVCB97_SPHV4T1_VMAP_RT_ARRAY_INDEX_FALSE                   0x00000000
#define NVCB97_SPHV4T1_VMAP_RT_ARRAY_INDEX_TRUE                    0x00000001
#define NVCB97_SPHV4T1_VMAP_VIEWPORT_INDEX                         MW(666:666)
#define NVCB97_SPHV4T1_VMAP_VIEWPORT_INDEX_FALSE                   0x00000000
#define NVCB97_SPHV4T1_VMAP_VIEWPORT_INDEX_TRUE                    0x00000001
#define NVCB97_SPHV4T1_VMAP_POINT_SIZE                             MW(667:667)
#define NVCB97_SPHV4T1_VMAP_POINT_SIZE_FALSE                       0x00000000
#define NVCB97_SPHV4T1_VMAP_POINT_SIZE_TRUE                        0x00000001
#define NVCB97_SPHV4T1_VMAP_POSITION_X                             MW(668:668)
#define NVCB97_SPHV4T1_VMAP_POSITION_X_FALSE                       0x00000000
#define NVCB97_SPHV4T1_VMAP_POSITION_X_TRUE                        0x00000001
#define NVCB97_SPHV4T1_VMAP_POSITION_Y                             MW(669:669)
#define NVCB97_SPHV4T1_VMAP_POSITION_Y_FALSE                       0x00000000
#define NVCB97_SPHV4T1_VMAP_POSITION_Y_TRUE                        0x00000001
#define NVCB97_SPHV4T1_VMAP_POSITION_Z                             MW(670:670)
#define NVCB97_SPHV4T1_VMAP_POSITION_Z_FALSE                       0x00000000
#define NVCB97_SPHV4T1_VMAP_POSITION_Z_TRUE                        0x00000001
#define NVCB97_SPHV4T1_VMAP_POSITION_W                             MW(671:671)
#define NVCB97_SPHV4T1_VMAP_POSITION_W_FALSE                       0x00000000
#define NVCB97_SPHV4T1_VMAP_POSITION_W_TRUE                        0x00000001
#define NVCB97_SPHV4T1_GENERIC_VMAP_X(i)                           MW((672+(i)*4):(672+(i)*4))
#define NVCB97_SPHV4T1_GENERIC_VMAP_X_FALSE                        0x00000000
#define NVCB97_SPHV4T1_GENERIC_VMAP_X_TRUE                         0x00000001
#define NVCB97_SPHV4T1_GENERIC_VMAP_Y(i)                           MW((673+(i)*4):(673+(i)*4))
#define NVCB97_SPHV4T1_GENERIC_VMAP_Y_FALSE                        0x00000000
#define NVCB97_SPHV4T1_GENERIC_VMAP_Y_TRUE                         0x00000001
#define NVCB97_SPHV4T1_GENERIC_VMAP_Z(i)                           MW((674+(i)*4):(674+(i)*4))
#define NVCB97_SPHV4T1_GENERIC_VMAP_Z_FALSE                        0x00000000
#define NVCB97_SPHV4T1_GENERIC_VMAP_Z_TRUE                         0x00000001
#define NVCB97_SPHV4T1_GENERIC_VMAP_W(i)                           MW((675+(i)*4):(675+(i)*4))
#define NVCB97_SPHV4T1_GENERIC_VMAP_W_FALSE                        0x00000000
#define NVCB97_SPHV4T1_GENERIC_VMAP_W_TRUE                         0x00000001
#define NVCB97_SPHV4T1_VMAP_COLOR_FRONT_DIFFUSE_RED                MW(800:800)
#define NVCB97_SPHV4T1_VMAP_COLOR_FRONT_DIFFUSE_RED_FALSE          0x00000000
#define NVCB97_SPHV4T1_VMAP_COLOR_FRONT_DIFFUSE_RED_TRUE           0x00000001
#define NVCB97_SPHV4T1_VMAP_COLOR_FRONT_DIFFUSE_GREEN              MW(801:801)
#define NVCB97_SPHV4T1_VMAP_COLOR_FRONT_DIFFUSE_GREEN_FALSE        0x00000000
#define NVCB97_SPHV4T1_VMAP_COLOR_FRONT_DIFFUSE_GREEN_TRUE         0x00000001
#define NVCB97_SPHV4T1_VMAP_COLOR_FRONT_DIFFUSE_BLUE               MW(802:802)
#define NVCB97_SPHV4T1_VMAP_COLOR_FRONT_DIFFUSE_BLUE_FALSE         0x00000000
#define NVCB97_SPHV4T1_VMAP_COLOR_FRONT_DIFFUSE_BLUE_TRUE          0x00000001
#define NVCB97_SPHV4T1_VMAP_COLOR_FRONT_DIFFUSE_ALPHA              MW(803:803)
#define NVCB97_SPHV4T1_VMAP_COLOR_FRONT_DIFFUSE_ALPHA_FALSE        0x00000000
#define NVCB97_SPHV4T1_VMAP_COLOR_FRONT_DIFFUSE_ALPHA_TRUE         0x00000001
#define NVCB97_SPHV4T1_VMAP_COLOR_FRONT_SPECULAR_RED               MW(804:804)
#define NVCB97_SPHV4T1_VMAP_COLOR_FRONT_SPECULAR_RED_FALSE         0x00000000
#define NVCB97_SPHV4T1_VMAP_COLOR_FRONT_SPECULAR_RED_TRUE          0x00000001
#define NVCB97_SPHV4T1_VMAP_COLOR_FRONT_SPECULAR_GREEN             MW(805:805)
#define NVCB97_SPHV4T1_VMAP_COLOR_FRONT_SPECULAR_GREEN_FALSE       0x00000000
#define NVCB97_SPHV4T1_VMAP_COLOR_FRONT_SPECULAR_GREEN_TRUE        0x00000001
#define NVCB97_SPHV4T1_VMAP_COLOR_FRONT_SPECULAR_BLUE              MW(806:806)
#define NVCB97_SPHV4T1_VMAP_COLOR_FRONT_SPECULAR_BLUE_FALSE        0x00000000
#define NVCB97_SPHV4T1_VMAP_COLOR_FRONT_SPECULAR_BLUE_TRUE         0x00000001
#define NVCB97_SPHV4T1_VMAP_COLOR_FRONT_SPECULAR_ALPHA             MW(807:807)
#define NVCB97_SPHV4T1_VMAP_COLOR_FRONT_SPECULAR_ALPHA_FALSE       0x00000000
#define NVCB97_SPHV4T1_VMAP_COLOR_FRONT_SPECULAR_ALPHA_TRUE        0x00000001
#define NVCB97_SPHV4T1_VMAP_COLOR_BACK_DIFFUSE_RED                 MW(808:808)
#define NVCB97_SPHV4T1_VMAP_COLOR_BACK_DIFFUSE_RED_FALSE           0x00000000
#define NVCB97_SPHV4T1_VMAP_COLOR_BACK_DIFFUSE_RED_TRUE            0x00000001
#define NVCB97_SPHV4T1_VMAP_COLOR_BACK_DIFFUSE_GREEN               MW(809:809)
#define NVCB97_SPHV4T1_VMAP_COLOR_BACK_DIFFUSE_GREEN_FALSE         0x00000000
#define NVCB97_SPHV4T1_VMAP_COLOR_BACK_DIFFUSE_GREEN_TRUE          0x00000001
#define NVCB97_SPHV4T1_VMAP_COLOR_BACK_DIFFUSE_BLUE                MW(810:810)
#define NVCB97_SPHV4T1_VMAP_COLOR_BACK_DIFFUSE_BLUE_FALSE          0x00000000
#define NVCB97_SPHV4T1_VMAP_COLOR_BACK_DIFFUSE_BLUE_TRUE           0x00000001
#define NVCB97_SPHV4T1_VMAP_COLOR_BACK_DIFFUSE_ALPHA               MW(811:811)
#define NVCB97_SPHV4T1_VMAP_COLOR_BACK_DIFFUSE_ALPHA_FALSE         0x00000000
#define NVCB97_SPHV4T1_VMAP_COLOR_BACK_DIFFUSE_ALPHA_TRUE          0x00000001
#define NVCB97_SPHV4T1_VMAP_COLOR_BACK_SPECULAR_RED                MW(812:812)
#define NVCB97_SPHV4T1_VMAP_COLOR_BACK_SPECULAR_RED_FALSE          0x00000000
#define NVCB97_SPHV4T1_VMAP_COLOR_BACK_SPECULAR_RED_TRUE           0x00000001
#define NVCB97_SPHV4T1_VMAP_COLOR_BACK_SPECULAR_GREEN              MW(813:813)
#define NVCB97_SPHV4T1_VMAP_COLOR_BACK_SPECULAR_GREEN_FALSE        0x00000000
#define NVCB97_SPHV4T1_VMAP_COLOR_BACK_SPECULAR_GREEN_TRUE         0x00000001
#define NVCB97_SPHV4T1_VMAP_COLOR_BACK_SPECULAR_BLUE               MW(814:814)
#define NVCB97_SPHV4T1_VMAP_COLOR_BACK_SPECULAR_BLUE_FALSE         0x00000000
#define NVCB97_SPHV4T1_VMAP_COLOR_BACK_SPECULAR_BLUE_TRUE          0x00000001
#define NVCB97_SPHV4T1_VMAP_COLOR_BACK_SPECULAR_ALPHA              MW(815:815)
#define NVCB97_SPHV4T1_VMAP_COLOR_BACK_SPECULAR_ALPHA_FALSE        0x00000000
#define NVCB97_SPHV4T1_VMAP_COLOR_BACK_SPECULAR_ALPHA_TRUE         0x00000001
#define NVCB97_SPHV4T1_VMAP_CLIP_DISTANCE0                         MW(816:816)
#define NVCB97_SPHV4T1_VMAP_CLIP_DISTANCE0_FALSE                   0x00000000
#define NVCB97_SPHV4T1_VMAP_CLIP_DISTANCE0_TRUE                    0x00000001
#define NVCB97_SPHV4T1_VMAP_CLIP_DISTANCE1                         MW(817:817)
#define NVCB97_SPHV4T1_VMAP_CLIP_DISTANCE1_FALSE                   0x00000000
#define NVCB97_SPHV4T1_VMAP_CLIP_DISTANCE1_TRUE                    0x00000001
#define NVCB97_SPHV4T1_VMAP_CLIP_DISTANCE2                         MW(818:818)
#define NVCB97_SPHV4T1_VMAP_CLIP_DISTANCE2_FALSE                   0x00000000
#define NVCB97_SPHV4T1_VMAP_CLIP_DISTANCE2_TRUE                    0x00000001
#define NVCB97_SPHV4T1_VMAP_CLIP_DISTANCE3                         MW(819:819)
#define NVCB97_SPHV4T1_VMAP_CLIP_DISTANCE3_FALSE                   0x00000000
#define NVCB97_SPHV4T1_VMAP_CLIP_DISTANCE3_TRUE                    0x00000001
#define NVCB97_SPHV4T1_VMAP_CLIP_DISTANCE4                         MW(820:820)
#define NVCB97_SPHV4T1_VMAP_CLIP_DISTANCE4_FALSE                   0x00000000
#define NVCB97_SPHV4T1_VMAP_CLIP_DISTANCE4_TRUE                    0x00000001
#define NVCB97_SPHV4T1_VMAP_CLIP_DISTANCE5                         MW(821:821)
#define NVCB97_SPHV4T1_VMAP_CLIP_DISTANCE5_FALSE                   0x00000000
#define NVCB97_SPHV4T1_VMAP_CLIP_DISTANCE5_TRUE                    0x00000001
#define NVCB97_SPHV4T1_VMAP_CLIP_DISTANCE6                         MW(822:822)
#define NVCB97_SPHV4T1_VMAP_CLIP_DISTANCE6_FALSE                   0x00000000
#define NVCB97_SPHV4T1_VMAP_CLIP_DISTANCE6_TRUE                    0x00000001
#define NVCB97_SPHV4T1_VMAP_CLIP_DISTANCE7                         MW(823:823)
#define NVCB97_SPHV4T1_VMAP_CLIP_DISTANCE7_FALSE                   0x00000000
#define NVCB97_SPHV4T1_VMAP_CLIP_DISTANCE7_TRUE                    0x00000001
#define NVCB97_SPHV4T1_VMAP_POINT_SPRITE_S                         MW(824:824)
#define NVCB97_SPHV4T1_VMAP_POINT_SPRITE_S_FALSE                   0x00000000
#define NVCB97_SPHV4T1_VMAP_POINT_SPRITE_S_TRUE                    0x00000001
#define NVCB97_SPHV4T1_VMAP_POINT_SPRITE_T                         MW(825:825)
#define NVCB97_SPHV4T1_VMAP_POINT_SPRITE_T_FALSE                   0x00000000
#define NVCB97_SPHV4T1_VMAP_POINT_SPRITE_T_TRUE                    0x00000001
#define NVCB97_SPHV4T1_VMAP_FOG_COORDINATE                         MW(826:826)
#define NVCB97_SPHV4T1_VMAP_FOG_COORDINATE_FALSE                   0x00000000
#define NVCB97_SPHV4T1_VMAP_FOG_COORDINATE_TRUE                    0x00000001
#define NVCB97_SPHV4T1_VMAP_TESSELLATION_EVALUATION_POINT_U        MW(828:828)
#define NVCB97_SPHV4T1_VMAP_TESSELLATION_EVALUATION_POINT_U_FALSE  0x00000000
#define NVCB97_SPHV4T1_VMAP_TESSELLATION_EVALUATION_POINT_U_TRUE   0x00000001
#define NVCB97_SPHV4T1_VMAP_TESSELLATION_EVALUATION_POINT_V        MW(829:829)
#define NVCB97_SPHV4T1_VMAP_TESSELLATION_EVALUATION_POINT_V_FALSE  0x00000000
#define NVCB97_SPHV4T1_VMAP_TESSELLATION_EVALUATION_POINT_V_TRUE   0x00000001
#define NVCB97_SPHV4T1_VMAP_INSTANCE_ID                            MW(830:830)
#define NVCB97_SPHV4T1_VMAP_INSTANCE_ID_FALSE                      0x00000000
#define NVCB97_SPHV4T1_VMAP_INSTANCE_ID_TRUE                       0x00000001
#define NVCB97_SPHV4T1_VMAP_VERTEX_ID                              MW(831:831)
#define NVCB97_SPHV4T1_VMAP_VERTEX_ID_FALSE                        0x00000000
#define NVCB97_SPHV4T1_VMAP_VERTEX_ID_TRUE                         0x00000001
#define NVCB97_SPHV4T1_TEX_VMAP_S(i)                               MW((832+(i)*4):(832+(i)*4))
#define NVCB97_SPHV4T1_TEX_VMAP_S_FALSE                            0x00000000
#define NVCB97_SPHV4T1_TEX_VMAP_S_TRUE                             0x00000001
#define NVCB97_SPHV4T1_TEX_VMAP_T(i)                               MW((833+(i)*4):(833+(i)*4))
#define NVCB97_SPHV4T1_TEX_VMAP_T_FALSE                            0x00000000
#define NVCB97_SPHV4T1_TEX_VMAP_T_TRUE                             0x00000001
#define NVCB97_SPHV4T1_TEX_VMAP_R(i)                               MW((834+(i)*4):(834+(i)*4))
#define NVCB97_SPHV4T1_TEX_VMAP_R_FALSE                            0x00000000
#define NVCB97_SPHV4T1_TEX_VMAP_R_TRUE                             0x00000001
#define NVCB97_SPHV4T1_TEX_VMAP_Q(i)                               MW((835+(i)*4):(835+(i)*4))
#define NVCB97_SPHV4T1_TEX_VMAP_Q_FALSE                            0x00000000
#define NVCB97_SPHV4T1_TEX_VMAP_Q_TRUE                             0x00000001
#define NVCB97_SPHV4T1_VMAP_VIEWPORT_MASK                          MW(872:872)
#define NVCB97_SPHV4T1_VMAP_VIEWPORT_MASK_FALSE                    0x00000000
#define NVCB97_SPHV4T1_VMAP_VIEWPORT_MASK_TRUE                     0x00000001
#define NVCB97_SPHV4T1_VMAP_VIEWPORT_MASK2                         MW(873:873)
#define NVCB97_SPHV4T1_VMAP_VIEWPORT_MASK2_FALSE                   0x00000000
#define NVCB97_SPHV4T1_VMAP_VIEWPORT_MASK2_TRUE                    0x00000001
#define NVCB97_SPHV4T1_VMAP_BARYCENTRIC0                           MW(874:874)
#define NVCB97_SPHV4T1_VMAP_BARYCENTRIC0_FALSE                     0x00000000
#define NVCB97_SPHV4T1_VMAP_BARYCENTRIC0_TRUE                      0x00000001
#define NVCB97_SPHV4T1_VMAP_BARYCENTRIC1                           MW(875:875)
#define NVCB97_SPHV4T1_VMAP_BARYCENTRIC1_FALSE                     0x00000000
#define NVCB97_SPHV4T1_VMAP_BARYCENTRIC1_TRUE                      0x00000001
#define NVCB97_SPHV4T1_VMAP_BARYCENTRIC2                           MW(876:876)
#define NVCB97_SPHV4T1_VMAP_BARYCENTRIC2_FALSE                     0x00000000
#define NVCB97_SPHV4T1_VMAP_BARYCENTRIC2_TRUE                      0x00000001
#define NVCB97_SPHV4T1_VMAP_BARYCENTRIC0_W                         MW(877:877)
#define NVCB97_SPHV4T1_VMAP_BARYCENTRIC0_W_FALSE                   0x00000000
#define NVCB97_SPHV4T1_VMAP_BARYCENTRIC0_W_TRUE                    0x00000001
#define NVCB97_SPHV4T1_VMAP_BARYCENTRIC1_W                         MW(878:878)
#define NVCB97_SPHV4T1_VMAP_BARYCENTRIC1_W_FALSE                   0x00000000
#define NVCB97_SPHV4T1_VMAP_BARYCENTRIC1_W_TRUE                    0x00000001
#define NVCB97_SPHV4T1_VMAP_BARYCENTRIC2_W                         MW(879:879)
#define NVCB97_SPHV4T1_VMAP_BARYCENTRIC2_W_FALSE                   0x00000000
#define NVCB97_SPHV4T1_VMAP_BARYCENTRIC2_W_TRUE                    0x00000001
#define NVCB97_SPHV4T1_PADDING(i)                                  MW((880+(i)*1):(880+(i)*1))


/*
** Shader Program Header State, Version 4, Type 2
 */

#define NVCB97_SPHV4T2_SPH_TYPE                                    MW(4:0)
#define NVCB97_SPHV4T2_SPH_TYPE_TYPE_01_VTG                        0x00000001
#define NVCB97_SPHV4T2_SPH_TYPE_TYPE_02_PS                         0x00000002
#define NVCB97_SPHV4T2_VERSION                                     MW(9:5)
#define NVCB97_SPHV4T2_SHADER_TYPE                                 MW(13:10)
#define NVCB97_SPHV4T2_SHADER_TYPE_VERTEX                          0x00000001
#define NVCB97_SPHV4T2_SHADER_TYPE_TESSELLATION_INIT               0x00000002
#define NVCB97_SPHV4T2_SHADER_TYPE_TESSELLATION                    0x00000003
#define NVCB97_SPHV4T2_SHADER_TYPE_GEOMETRY                        0x00000004
#define NVCB97_SPHV4T2_SHADER_TYPE_PIXEL                           0x00000005
#define NVCB97_SPHV4T2_MRT_ENABLE                                  MW(14:14)
#define NVCB97_SPHV4T2_MRT_ENABLE_FALSE                            0x00000000
#define NVCB97_SPHV4T2_MRT_ENABLE_TRUE                             0x00000001
#define NVCB97_SPHV4T2_KILLS_PIXELS                                MW(15:15)
#define NVCB97_SPHV4T2_KILLS_PIXELS_FALSE                          0x00000000
#define NVCB97_SPHV4T2_KILLS_PIXELS_TRUE                           0x00000001
#define NVCB97_SPHV4T2_DOES_GLOBAL_STORE                           MW(16:16)
#define NVCB97_SPHV4T2_DOES_GLOBAL_STORE_FALSE                     0x00000000
#define NVCB97_SPHV4T2_DOES_GLOBAL_STORE_TRUE                      0x00000001
#define NVCB97_SPHV4T2_SASS_VERSION                                MW(20:17)
#define NVCB97_SPHV4T2_RESERVED_COMMON_A                           MW(22:22)
#define NVCB97_SPHV4T2_RESERVED_COMMON_A_FALSE                     0x00000000
#define NVCB97_SPHV4T2_RESERVED_COMMON_A_TRUE                      0x00000001
#define NVCB97_SPHV4T2_RESERVED_COMMON_B                           MW(27:26)
#define NVCB97_SPHV4T2_STREAM_OUT_MASK                             MW(31:28)
#define NVCB97_SPHV4T2_SHADER_LOCAL_MEMORY_LOW_SIZE                MW(55:32)
#define NVCB97_SPHV4T2_PER_PATCH_ATTRIBUTE_COUNT                   MW(63:56)
#define NVCB97_SPHV4T2_SHADER_LOCAL_MEMORY_HIGH_SIZE               MW(87:64)
#define NVCB97_SPHV4T2_THREADS_PER_INPUT_PRIMITIVE                 MW(95:88)
#define NVCB97_SPHV4T2_RESERVED_COMMON_C                           MW(119:96)
#define NVCB97_SPHV4T2_OUTPUT_TOPOLOGY                             MW(123:120)
#define NVCB97_SPHV4T2_OUTPUT_TOPOLOGY_POINTLIST                   0x00000001
#define NVCB97_SPHV4T2_OUTPUT_TOPOLOGY_LINESTRIP                   0x00000006
#define NVCB97_SPHV4T2_OUTPUT_TOPOLOGY_TRIANGLESTRIP               0x00000007
#define NVCB97_SPHV4T2_MAX_OUTPUT_VERTEX_COUNT                     MW(139:128)
#define NVCB97_SPHV4T2_STORE_REQ_START                             MW(147:140)
#define NVCB97_SPHV4T2_STORE_REQ_END                               MW(159:152)
#define NVCB97_SPHV4T2_IMAP_VPRS_TABLE_INDEX                       MW(183:183)
#define NVCB97_SPHV4T2_IMAP_VPRS_TABLE_INDEX_FALSE                 0x00000000
#define NVCB97_SPHV4T2_IMAP_VPRS_TABLE_INDEX_TRUE                  0x00000001
#define NVCB97_SPHV4T2_IMAP_PRIMITIVE_ID                           MW(184:184)
#define NVCB97_SPHV4T2_IMAP_PRIMITIVE_ID_FALSE                     0x00000000
#define NVCB97_SPHV4T2_IMAP_PRIMITIVE_ID_TRUE                      0x00000001
#define NVCB97_SPHV4T2_IMAP_RT_ARRAY_INDEX                         MW(185:185)
#define NVCB97_SPHV4T2_IMAP_RT_ARRAY_INDEX_FALSE                   0x00000000
#define NVCB97_SPHV4T2_IMAP_RT_ARRAY_INDEX_TRUE                    0x00000001
#define NVCB97_SPHV4T2_IMAP_VIEWPORT_INDEX                         MW(186:186)
#define NVCB97_SPHV4T2_IMAP_VIEWPORT_INDEX_FALSE                   0x00000000
#define NVCB97_SPHV4T2_IMAP_VIEWPORT_INDEX_TRUE                    0x00000001
#define NVCB97_SPHV4T2_IMAP_POINT_SIZE                             MW(187:187)
#define NVCB97_SPHV4T2_IMAP_POINT_SIZE_FALSE                       0x00000000
#define NVCB97_SPHV4T2_IMAP_POINT_SIZE_TRUE                        0x00000001
#define NVCB97_SPHV4T2_IMAP_POSITION_X                             MW(188:188)
#define NVCB97_SPHV4T2_IMAP_POSITION_X_FALSE                       0x00000000
#define NVCB97_SPHV4T2_IMAP_POSITION_X_TRUE                        0x00000001
#define NVCB97_SPHV4T2_IMAP_POSITION_Y                             MW(189:189)
#define NVCB97_SPHV4T2_IMAP_POSITION_Y_FALSE                       0x00000000
#define NVCB97_SPHV4T2_IMAP_POSITION_Y_TRUE                        0x00000001
#define NVCB97_SPHV4T2_IMAP_POSITION_Z                             MW(190:190)
#define NVCB97_SPHV4T2_IMAP_POSITION_Z_FALSE                       0x00000000
#define NVCB97_SPHV4T2_IMAP_POSITION_Z_TRUE                        0x00000001
#define NVCB97_SPHV4T2_IMAP_POSITION_W                             MW(191:191)
#define NVCB97_SPHV4T2_IMAP_POSITION_W_FALSE                       0x00000000
#define NVCB97_SPHV4T2_IMAP_POSITION_W_TRUE                        0x00000001
#define NVCB97_SPHV4T2_GENERIC_IMAP_X(i)                           MW((193+(i)*8):(192+(i)*8))
#define NVCB97_SPHV4T2_GENERIC_IMAP_X_UNUSED                       0x00000000
#define NVCB97_SPHV4T2_GENERIC_IMAP_X_CONSTANT                     0x00000001
#define NVCB97_SPHV4T2_GENERIC_IMAP_X_PERSPECTIVE                  0x00000002
#define NVCB97_SPHV4T2_GENERIC_IMAP_X_SCREEN_LINEAR                0x00000003
#define NVCB97_SPHV4T2_GENERIC_IMAP_Y(i)                           MW((195+(i)*8):(194+(i)*8))
#define NVCB97_SPHV4T2_GENERIC_IMAP_Y_UNUSED                       0x00000000
#define NVCB97_SPHV4T2_GENERIC_IMAP_Y_CONSTANT                     0x00000001
#define NVCB97_SPHV4T2_GENERIC_IMAP_Y_PERSPECTIVE                  0x00000002
#define NVCB97_SPHV4T2_GENERIC_IMAP_Y_SCREEN_LINEAR                0x00000003
#define NVCB97_SPHV4T2_GENERIC_IMAP_Z(i)                           MW((197+(i)*8):(196+(i)*8))
#define NVCB97_SPHV4T2_GENERIC_IMAP_Z_UNUSED                       0x00000000
#define NVCB97_SPHV4T2_GENERIC_IMAP_Z_CONSTANT                     0x00000001
#define NVCB97_SPHV4T2_GENERIC_IMAP_Z_PERSPECTIVE                  0x00000002
#define NVCB97_SPHV4T2_GENERIC_IMAP_Z_SCREEN_LINEAR                0x00000003
#define NVCB97_SPHV4T2_GENERIC_IMAP_W(i)                           MW((199+(i)*8):(198+(i)*8))
#define NVCB97_SPHV4T2_GENERIC_IMAP_W_UNUSED                       0x00000000
#define NVCB97_SPHV4T2_GENERIC_IMAP_W_CONSTANT                     0x00000001
#define NVCB97_SPHV4T2_GENERIC_IMAP_W_PERSPECTIVE                  0x00000002
#define NVCB97_SPHV4T2_GENERIC_IMAP_W_SCREEN_LINEAR                0x00000003
#define NVCB97_SPHV4T2_IMAP_COLOR_DIFFUSE_RED                      MW(449:448)
#define NVCB97_SPHV4T2_IMAP_COLOR_DIFFUSE_RED_UNUSED               0x00000000
#define NVCB97_SPHV4T2_IMAP_COLOR_DIFFUSE_RED_CONSTANT             0x00000001
#define NVCB97_SPHV4T2_IMAP_COLOR_DIFFUSE_RED_PERSPECTIVE          0x00000002
#define NVCB97_SPHV4T2_IMAP_COLOR_DIFFUSE_RED_SCREEN_LINEAR        0x00000003
#define NVCB97_SPHV4T2_IMAP_COLOR_DIFFUSE_GREEN                    MW(451:450)
#define NVCB97_SPHV4T2_IMAP_COLOR_DIFFUSE_GREEN_UNUSED             0x00000000
#define NVCB97_SPHV4T2_IMAP_COLOR_DIFFUSE_GREEN_CONSTANT           0x00000001
#define NVCB97_SPHV4T2_IMAP_COLOR_DIFFUSE_GREEN_PERSPECTIVE        0x00000002
#define NVCB97_SPHV4T2_IMAP_COLOR_DIFFUSE_GREEN_SCREEN_LINEAR      0x00000003
#define NVCB97_SPHV4T2_IMAP_COLOR_DIFFUSE_BLUE                     MW(453:452)
#define NVCB97_SPHV4T2_IMAP_COLOR_DIFFUSE_BLUE_UNUSED              0x00000000
#define NVCB97_SPHV4T2_IMAP_COLOR_DIFFUSE_BLUE_CONSTANT            0x00000001
#define NVCB97_SPHV4T2_IMAP_COLOR_DIFFUSE_BLUE_PERSPECTIVE         0x00000002
#define NVCB97_SPHV4T2_IMAP_COLOR_DIFFUSE_BLUE_SCREEN_LINEAR       0x00000003
#define NVCB97_SPHV4T2_IMAP_COLOR_DIFFUSE_ALPHA                    MW(455:454)
#define NVCB97_SPHV4T2_IMAP_COLOR_DIFFUSE_ALPHA_UNUSED             0x00000000
#define NVCB97_SPHV4T2_IMAP_COLOR_DIFFUSE_ALPHA_CONSTANT           0x00000001
#define NVCB97_SPHV4T2_IMAP_COLOR_DIFFUSE_ALPHA_PERSPECTIVE        0x00000002
#define NVCB97_SPHV4T2_IMAP_COLOR_DIFFUSE_ALPHA_SCREEN_LINEAR      0x00000003
#define NVCB97_SPHV4T2_IMAP_COLOR_SPECULAR_RED                     MW(457:456)
#define NVCB97_SPHV4T2_IMAP_COLOR_SPECULAR_RED_UNUSED              0x00000000
#define NVCB97_SPHV4T2_IMAP_COLOR_SPECULAR_RED_CONSTANT            0x00000001
#define NVCB97_SPHV4T2_IMAP_COLOR_SPECULAR_RED_PERSPECTIVE         0x00000002
#define NVCB97_SPHV4T2_IMAP_COLOR_SPECULAR_RED_SCREEN_LINEAR       0x00000003
#define NVCB97_SPHV4T2_IMAP_COLOR_SPECULAR_GREEN                   MW(459:458)
#define NVCB97_SPHV4T2_IMAP_COLOR_SPECULAR_GREEN_UNUSED            0x00000000
#define NVCB97_SPHV4T2_IMAP_COLOR_SPECULAR_GREEN_CONSTANT          0x00000001
#define NVCB97_SPHV4T2_IMAP_COLOR_SPECULAR_GREEN_PERSPECTIVE       0x00000002
#define NVCB97_SPHV4T2_IMAP_COLOR_SPECULAR_GREEN_SCREEN_LINEAR     0x00000003
#define NVCB97_SPHV4T2_IMAP_COLOR_SPECULAR_BLUE                    MW(461:460)
#define NVCB97_SPHV4T2_IMAP_COLOR_SPECULAR_BLUE_UNUSED             0x00000000
#define NVCB97_SPHV4T2_IMAP_COLOR_SPECULAR_BLUE_CONSTANT           0x00000001
#define NVCB97_SPHV4T2_IMAP_COLOR_SPECULAR_BLUE_PERSPECTIVE        0x00000002
#define NVCB97_SPHV4T2_IMAP_COLOR_SPECULAR_BLUE_SCREEN_LINEAR      0x00000003
#define NVCB97_SPHV4T2_IMAP_COLOR_SPECULAR_ALPHA                   MW(463:462)
#define NVCB97_SPHV4T2_IMAP_COLOR_SPECULAR_ALPHA_UNUSED            0x00000000
#define NVCB97_SPHV4T2_IMAP_COLOR_SPECULAR_ALPHA_CONSTANT          0x00000001
#define NVCB97_SPHV4T2_IMAP_COLOR_SPECULAR_ALPHA_PERSPECTIVE       0x00000002
#define NVCB97_SPHV4T2_IMAP_COLOR_SPECULAR_ALPHA_SCREEN_LINEAR     0x00000003
#define NVCB97_SPHV4T2_IMAP_CLIP_DISTANCE0                         MW(464:464)
#define NVCB97_SPHV4T2_IMAP_CLIP_DISTANCE0_FALSE                   0x00000000
#define NVCB97_SPHV4T2_IMAP_CLIP_DISTANCE0_TRUE                    0x00000001
#define NVCB97_SPHV4T2_IMAP_CLIP_DISTANCE1                         MW(465:465)
#define NVCB97_SPHV4T2_IMAP_CLIP_DISTANCE1_FALSE                   0x00000000
#define NVCB97_SPHV4T2_IMAP_CLIP_DISTANCE1_TRUE                    0x00000001
#define NVCB97_SPHV4T2_IMAP_CLIP_DISTANCE2                         MW(466:466)
#define NVCB97_SPHV4T2_IMAP_CLIP_DISTANCE2_FALSE                   0x00000000
#define NVCB97_SPHV4T2_IMAP_CLIP_DISTANCE2_TRUE                    0x00000001
#define NVCB97_SPHV4T2_IMAP_CLIP_DISTANCE3                         MW(467:467)
#define NVCB97_SPHV4T2_IMAP_CLIP_DISTANCE3_FALSE                   0x00000000
#define NVCB97_SPHV4T2_IMAP_CLIP_DISTANCE3_TRUE                    0x00000001
#define NVCB97_SPHV4T2_IMAP_CLIP_DISTANCE4                         MW(468:468)
#define NVCB97_SPHV4T2_IMAP_CLIP_DISTANCE4_FALSE                   0x00000000
#define NVCB97_SPHV4T2_IMAP_CLIP_DISTANCE4_TRUE                    0x00000001
#define NVCB97_SPHV4T2_IMAP_CLIP_DISTANCE5                         MW(469:469)
#define NVCB97_SPHV4T2_IMAP_CLIP_DISTANCE5_FALSE                   0x00000000
#define NVCB97_SPHV4T2_IMAP_CLIP_DISTANCE5_TRUE                    0x00000001
#define NVCB97_SPHV4T2_IMAP_CLIP_DISTANCE6                         MW(470:470)
#define NVCB97_SPHV4T2_IMAP_CLIP_DISTANCE6_FALSE                   0x00000000
#define NVCB97_SPHV4T2_IMAP_CLIP_DISTANCE6_TRUE                    0x00000001
#define NVCB97_SPHV4T2_IMAP_CLIP_DISTANCE7                         MW(471:471)
#define NVCB97_SPHV4T2_IMAP_CLIP_DISTANCE7_FALSE                   0x00000000
#define NVCB97_SPHV4T2_IMAP_CLIP_DISTANCE7_TRUE                    0x00000001
#define NVCB97_SPHV4T2_IMAP_POINT_SPRITE_S                         MW(472:472)
#define NVCB97_SPHV4T2_IMAP_POINT_SPRITE_S_FALSE                   0x00000000
#define NVCB97_SPHV4T2_IMAP_POINT_SPRITE_S_TRUE                    0x00000001
#define NVCB97_SPHV4T2_IMAP_POINT_SPRITE_T                         MW(473:473)
#define NVCB97_SPHV4T2_IMAP_POINT_SPRITE_T_FALSE                   0x00000000
#define NVCB97_SPHV4T2_IMAP_POINT_SPRITE_T_TRUE                    0x00000001
#define NVCB97_SPHV4T2_IMAP_FOG_COORDINATE                         MW(474:474)
#define NVCB97_SPHV4T2_IMAP_FOG_COORDINATE_FALSE                   0x00000000
#define NVCB97_SPHV4T2_IMAP_FOG_COORDINATE_TRUE                    0x00000001
#define NVCB97_SPHV4T2_IMAP_TESSELLATION_EVALUATION_POINT_U        MW(476:476)
#define NVCB97_SPHV4T2_IMAP_TESSELLATION_EVALUATION_POINT_U_FALSE  0x00000000
#define NVCB97_SPHV4T2_IMAP_TESSELLATION_EVALUATION_POINT_U_TRUE   0x00000001
#define NVCB97_SPHV4T2_IMAP_TESSELLATION_EVALUATION_POINT_V        MW(477:477)
#define NVCB97_SPHV4T2_IMAP_TESSELLATION_EVALUATION_POINT_V_FALSE  0x00000000
#define NVCB97_SPHV4T2_IMAP_TESSELLATION_EVALUATION_POINT_V_TRUE   0x00000001
#define NVCB97_SPHV4T2_IMAP_INSTANCE_ID                            MW(478:478)
#define NVCB97_SPHV4T2_IMAP_INSTANCE_ID_FALSE                      0x00000000
#define NVCB97_SPHV4T2_IMAP_INSTANCE_ID_TRUE                       0x00000001
#define NVCB97_SPHV4T2_IMAP_VERTEX_ID                              MW(479:479)
#define NVCB97_SPHV4T2_IMAP_VERTEX_ID_FALSE                        0x00000000
#define NVCB97_SPHV4T2_IMAP_VERTEX_ID_TRUE                         0x00000001
#define NVCB97_SPHV4T2_TEX_IMAP_S(i)                               MW((481+(i)*8):(480+(i)*8))
#define NVCB97_SPHV4T2_TEX_IMAP_S_UNUSED                           0x00000000
#define NVCB97_SPHV4T2_TEX_IMAP_S_CONSTANT                         0x00000001
#define NVCB97_SPHV4T2_TEX_IMAP_S_PERSPECTIVE                      0x00000002
#define NVCB97_SPHV4T2_TEX_IMAP_S_SCREEN_LINEAR                    0x00000003
#define NVCB97_SPHV4T2_TEX_IMAP_T(i)                               MW((483+(i)*8):(482+(i)*8))
#define NVCB97_SPHV4T2_TEX_IMAP_T_UNUSED                           0x00000000
#define NVCB97_SPHV4T2_TEX_IMAP_T_CONSTANT                         0x00000001
#define NVCB97_SPHV4T2_TEX_IMAP_T_PERSPECTIVE                      0x00000002
#define NVCB97_SPHV4T2_TEX_IMAP_T_SCREEN_LINEAR                    0x00000003
#define NVCB97_SPHV4T2_TEX_IMAP_R(i)                               MW((485+(i)*8):(484+(i)*8))
#define NVCB97_SPHV4T2_TEX_IMAP_R_UNUSED                           0x00000000
#define NVCB97_SPHV4T2_TEX_IMAP_R_CONSTANT                         0x00000001
#define NVCB97_SPHV4T2_TEX_IMAP_R_PERSPECTIVE                      0x00000002
#define NVCB97_SPHV4T2_TEX_IMAP_R_SCREEN_LINEAR                    0x00000003
#define NVCB97_SPHV4T2_TEX_IMAP_Q(i)                               MW((487+(i)*8):(486+(i)*8))
#define NVCB97_SPHV4T2_TEX_IMAP_Q_UNUSED                           0x00000000
#define NVCB97_SPHV4T2_TEX_IMAP_Q_CONSTANT                         0x00000001
#define NVCB97_SPHV4T2_TEX_IMAP_Q_PERSPECTIVE                      0x00000002
#define NVCB97_SPHV4T2_TEX_IMAP_Q_SCREEN_LINEAR                    0x00000003
#define NVCB97_SPHV4T2_IMAP_VIEWPORT_MASK                          MW(561:560)
#define NVCB97_SPHV4T2_IMAP_VIEWPORT_MASK_UNUSED                   0x00000000
#define NVCB97_SPHV4T2_IMAP_VIEWPORT_MASK_CONSTANT                 0x00000001
#define NVCB97_SPHV4T2_IMAP_VIEWPORT_MASK_PERSPECTIVE              0x00000002
#define NVCB97_SPHV4T2_IMAP_VIEWPORT_MASK_SCREEN_LINEAR            0x00000003
#define NVCB97_SPHV4T2_IMAP_VIEWPORT_MASK2                         MW(563:562)
#define NVCB97_SPHV4T2_IMAP_VIEWPORT_MASK2_UNUSED                  0x00000000
#define NVCB97_SPHV4T2_IMAP_VIEWPORT_MASK2_CONSTANT                0x00000001
#define NVCB97_SPHV4T2_IMAP_VIEWPORT_MASK2_PERSPECTIVE             0x00000002
#define NVCB97_SPHV4T2_IMAP_VIEWPORT_MASK2_SCREEN_LINEAR           0x00000003
#define NVCB97_SPHV4T2_IMAP_BARYCENTRIC0                           MW(565:564)
#define NVCB97_SPHV4T2_IMAP_BARYCENTRIC0_UNUSED                    0x00000000
#define NVCB97_SPHV4T2_IMAP_BARYCENTRIC0_CONSTANT                  0x00000001
#define NVCB97_SPHV4T2_IMAP_BARYCENTRIC0_PERSPECTIVE               0x00000002
#define NVCB97_SPHV4T2_IMAP_BARYCENTRIC0_SCREEN_LINEAR             0x00000003
#define NVCB97_SPHV4T2_IMAP_BARYCENTRIC1                           MW(567:566)
#define NVCB97_SPHV4T2_IMAP_BARYCENTRIC1_UNUSED                    0x00000000
#define NVCB97_SPHV4T2_IMAP_BARYCENTRIC1_CONSTANT                  0x00000001
#define NVCB97_SPHV4T2_IMAP_BARYCENTRIC1_PERSPECTIVE               0x00000002
#define NVCB97_SPHV4T2_IMAP_BARYCENTRIC1_SCREEN_LINEAR             0x00000003
#define NVCB97_SPHV4T2_IMAP_BARYCENTRIC2                           MW(569:568)
#define NVCB97_SPHV4T2_IMAP_BARYCENTRIC2_UNUSED                    0x00000000
#define NVCB97_SPHV4T2_IMAP_BARYCENTRIC2_CONSTANT                  0x00000001
#define NVCB97_SPHV4T2_IMAP_BARYCENTRIC2_PERSPECTIVE               0x00000002
#define NVCB97_SPHV4T2_IMAP_BARYCENTRIC2_SCREEN_LINEAR             0x00000003
#define NVCB97_SPHV4T2_IMAP_BARYCENTRIC0_W                         MW(571:570)
#define NVCB97_SPHV4T2_IMAP_BARYCENTRIC0_W_UNUSED                  0x00000000
#define NVCB97_SPHV4T2_IMAP_BARYCENTRIC0_W_CONSTANT                0x00000001
#define NVCB97_SPHV4T2_IMAP_BARYCENTRIC0_W_PERSPECTIVE             0x00000002
#define NVCB97_SPHV4T2_IMAP_BARYCENTRIC0_W_SCREEN_LINEAR           0x00000003
#define NVCB97_SPHV4T2_IMAP_BARYCENTRIC1_W                         MW(573:572)
#define NVCB97_SPHV4T2_IMAP_BARYCENTRIC1_W_UNUSED                  0x00000000
#define NVCB97_SPHV4T2_IMAP_BARYCENTRIC1_W_CONSTANT                0x00000001
#define NVCB97_SPHV4T2_IMAP_BARYCENTRIC1_W_PERSPECTIVE             0x00000002
#define NVCB97_SPHV4T2_IMAP_BARYCENTRIC1_W_SCREEN_LINEAR           0x00000003
#define NVCB97_SPHV4T2_IMAP_BARYCENTRIC2_W                         MW(575:574)
#define NVCB97_SPHV4T2_IMAP_BARYCENTRIC2_W_UNUSED                  0x00000000
#define NVCB97_SPHV4T2_IMAP_BARYCENTRIC2_W_CONSTANT                0x00000001
#define NVCB97_SPHV4T2_IMAP_BARYCENTRIC2_W_PERSPECTIVE             0x00000002
#define NVCB97_SPHV4T2_IMAP_BARYCENTRIC2_W_SCREEN_LINEAR           0x00000003
#define NVCB97_SPHV4T2_OMAP_RED(i)                                 MW((576+(i)*4):(576+(i)*4))
#define NVCB97_SPHV4T2_OMAP_RED_FALSE                              0x00000000
#define NVCB97_SPHV4T2_OMAP_RED_TRUE                               0x00000001
#define NVCB97_SPHV4T2_OMAP_GREEN(i)                               MW((577+(i)*4):(577+(i)*4))
#define NVCB97_SPHV4T2_OMAP_GREEN_FALSE                            0x00000000
#define NVCB97_SPHV4T2_OMAP_GREEN_TRUE                             0x00000001
#define NVCB97_SPHV4T2_OMAP_BLUE(i)                                MW((578+(i)*4):(578+(i)*4))
#define NVCB97_SPHV4T2_OMAP_BLUE_FALSE                             0x00000000
#define NVCB97_SPHV4T2_OMAP_BLUE_TRUE                              0x00000001
#define NVCB97_SPHV4T2_OMAP_ALPHA(i)                               MW((579+(i)*4):(579+(i)*4))
#define NVCB97_SPHV4T2_OMAP_ALPHA_FALSE                            0x00000000
#define NVCB97_SPHV4T2_OMAP_ALPHA_TRUE                             0x00000001
#define NVCB97_SPHV4T2_OMAP_SAMPLE_MASK                            MW(608:608)
#define NVCB97_SPHV4T2_OMAP_SAMPLE_MASK_FALSE                      0x00000000
#define NVCB97_SPHV4T2_OMAP_SAMPLE_MASK_TRUE                       0x00000001
#define NVCB97_SPHV4T2_OMAP_DEPTH                                  MW(609:609)
#define NVCB97_SPHV4T2_OMAP_DEPTH_FALSE                            0x00000000
#define NVCB97_SPHV4T2_OMAP_DEPTH_TRUE                             0x00000001
#define NVCB97_SPHV4T2_READS_INTERLOCK_TICKET                      MW(610:610)
#define NVCB97_SPHV4T2_READS_INTERLOCK_TICKET_FALSE                0x00000000
#define NVCB97_SPHV4T2_READS_INTERLOCK_TICKET_TRUE                 0x00000001
#define NVCB97_SPHV4T2_USES_INNER_COVERAGE                         MW(611:611)
#define NVCB97_SPHV4T2_USES_INNER_COVERAGE_FALSE                   0x00000000
#define NVCB97_SPHV4T2_USES_INNER_COVERAGE_TRUE                    0x00000001
#define NVCB97_SPHV4T2_IMAP_SYSTEM_VALUES_A_EXT(i)                 MW((640+(i)*1):(640+(i)*1))
#define NVCB97_SPHV4T2_IMAP_SYSTEM_VALUES_B_EXT(i)                 MW((664+(i)*1):(664+(i)*1))
#define NVCB97_SPHV4T2_GENERIC_IMAP_X_EXT(i)                       MW((672+(i)*4):(672+(i)*4))
#define NVCB97_SPHV4T2_GENERIC_IMAP_X_EXT_FALSE                    0x00000000
#define NVCB97_SPHV4T2_GENERIC_IMAP_X_EXT_TRUE                     0x00000001
#define NVCB97_SPHV4T2_GENERIC_IMAP_Y_EXT(i)                       MW((673+(i)*4):(673+(i)*4))
#define NVCB97_SPHV4T2_GENERIC_IMAP_Y_EXT_FALSE                    0x00000000
#define NVCB97_SPHV4T2_GENERIC_IMAP_Y_EXT_TRUE                     0x00000001
#define NVCB97_SPHV4T2_GENERIC_IMAP_Z_EXT(i)                       MW((674+(i)*4):(674+(i)*4))
#define NVCB97_SPHV4T2_GENERIC_IMAP_Z_EXT_FALSE                    0x00000000
#define NVCB97_SPHV4T2_GENERIC_IMAP_Z_EXT_TRUE                     0x00000001
#define NVCB97_SPHV4T2_GENERIC_IMAP_W_EXT(i)                       MW((675+(i)*4):(675+(i)*4))
#define NVCB97_SPHV4T2_GENERIC_IMAP_W_EXT_FALSE                    0x00000000
#define NVCB97_SPHV4T2_GENERIC_IMAP_W_EXT_TRUE                     0x00000001
#define NVCB97_SPHV4T2_IMAP_COLOR_DIFFUSE_RED_EXT                  MW(800:800)
#define NVCB97_SPHV4T2_IMAP_COLOR_DIFFUSE_GREEN_EXT                MW(801:801)
#define NVCB97_SPHV4T2_IMAP_COLOR_DIFFUSE_BLUE_EXT                 MW(802:802)
#define NVCB97_SPHV4T2_IMAP_COLOR_DIFFUSE_ALPHA_EXT                MW(803:803)
#define NVCB97_SPHV4T2_IMAP_COLOR_SPECULAR_RED_EXT                 MW(804:804)
#define NVCB97_SPHV4T2_IMAP_COLOR_SPECULAR_GREEN_EXT               MW(805:805)
#define NVCB97_SPHV4T2_IMAP_COLOR_SPECULAR_BLUE_EXT                MW(806:806)
#define NVCB97_SPHV4T2_IMAP_COLOR_SPECULAR_ALPHA_EXT               MW(807:807)
#define NVCB97_SPHV4T2_IMAP_SYSTEM_VALUES_C_EXT(i)                 MW((808+(i)*1):(808+(i)*1))
#define NVCB97_SPHV4T2_TEX_IMAP_S_EXT(i)                           MW((824+(i)*4):(824+(i)*4))
#define NVCB97_SPHV4T2_TEX_IMAP_S_EXT_FALSE                        0x00000000
#define NVCB97_SPHV4T2_TEX_IMAP_S_EXT_TRUE                         0x00000001
#define NVCB97_SPHV4T2_TEX_IMAP_T_EXT(i)                           MW((825+(i)*4):(825+(i)*4))
#define NVCB97_SPHV4T2_TEX_IMAP_T_EXT_FALSE                        0x00000000
#define NVCB97_SPHV4T2_TEX_IMAP_T_EXT_TRUE                         0x00000001
#define NVCB97_SPHV4T2_TEX_IMAP_R_EXT(i)                           MW((826+(i)*4):(826+(i)*4))
#define NVCB97_SPHV4T2_TEX_IMAP_R_EXT_FALSE                        0x00000000
#define NVCB97_SPHV4T2_TEX_IMAP_R_EXT_TRUE                         0x00000001
#define NVCB97_SPHV4T2_TEX_IMAP_Q_EXT(i)                           MW((827+(i)*4):(827+(i)*4))
#define NVCB97_SPHV4T2_TEX_IMAP_Q_EXT_FALSE                        0x00000000
#define NVCB97_SPHV4T2_TEX_IMAP_Q_EXT_TRUE                         0x00000001
#define NVCB97_SPHV4T2_IMAP_VIEWPORT_MASK_EXT                      MW(864:864)
#define NVCB97_SPHV4T2_IMAP_VIEWPORT_MASK2_EXT                     MW(865:865)
#define NVCB97_SPHV4T2_IMAP_BARYCENTRIC0_EXT                       MW(866:866)
#define NVCB97_SPHV4T2_IMAP_BARYCENTRIC1_EXT                       MW(867:867)
#define NVCB97_SPHV4T2_IMAP_BARYCENTRIC2_EXT                       MW(868:868)
#define NVCB97_SPHV4T2_IMAP_BARYCENTRIC0_W_EXT                     MW(869:869)
#define NVCB97_SPHV4T2_IMAP_BARYCENTRIC1_W_EXT                     MW(870:870)
#define NVCB97_SPHV4T2_IMAP_BARYCENTRIC2_W_EXT                     MW(871:871)
#define NVCB97_SPHV4T2_PADDING_C(i)                                MW((872+(i)*1):(872+(i)*1))



#endif // #ifndef __CLCB97SPH_H__
